#define _VDACTIONBUTTON_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdActionButton.cxx                                *
*  Date: 21-01-93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*                                                          *
*     experimental realization of class VdActionButton:    *
*                                                          *
*     Methods:	                                           * 
*                                                          *
*                                                          *
*     Interface                                            *
*                                                          *
*                                                          *
***********************************************************/

/******************    dependences    *********************/


#include <Vd/VdActionButton.hxx>

#include <X11/Intrinsic.h>

#include <Xm/Xm.h>
#include <Xm/CascadeB.h>

#include <iostream.h>

extern "C" {
#include <stdio.h>
}


VdActionButton::VdActionButton( Widget parent, 
		VdFeature & aw,
		VdEvent * event,
		VdHandle *handle,
		VdPicture * picture)
{
	parentWidget = parent;
	theLabelString = (handle->name).charptr();
	theEvent = event;
	theHandle = handle;
	thePicture = picture;
	parentWindow = aw;
	theButton = XmCreateCascadeButton(
			parentWidget,
			theLabelString, NULL, 0);
	XtManageChild( theButton );
	addCB(theButton, activated);
	watchDestroying(theButton);
}

VdActionButton::~VdActionButton( void )
{
	XtDestroyWidget(theButton);
}

void VdActionButton::handleActivated( void )
{
	if (!theHandle || !thePicture || !theEvent) return;
	theHandle->execute(theEvent , thePicture);
}

Widget VdActionButton::getWidget( void )
{
	return theButton;
}

#undef _VDACTIONBUTTON_CXX
