#ifndef _VDACTIONBUTTON_HXX
#define _VDACTIONBUTTON_HXX

/***********************************************************
*                 VISAMAD.defgraph                         *
*             ==========================                   *
*  File: VdActionButton.hxx                                *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*  Comment                                                 *
*     experimental declaration of class VdActionButton:    *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdActionButton;

/******************    dependences    *********************/

#include <X11/Intrinsic.h>
#include <Vd/VdCBmanager.hxx>
#include <Vd/VdHandle.hxx>
#include <Vd/VdFeature.hxx>
#include <Vd/VdDestruction.hxx>

class VdPicture;

class VdActionButton: public VdCBmanager, 
		      public VdDestruction  {
   private:
	VdFeature parentWindow;

   protected:
	~VdActionButton( void ); 
	Widget theButton;
	Widget parentWidget;
	VdEvent *theEvent;
	VdHandle *theHandle;
	VdPicture *thePicture;
	String theLabelString;

   public:
	VdActionButton( Widget parent,
		VdFeature & window,
		VdEvent * event ,
		VdHandle * handle ,
		VdPicture * picture = NULL);
	Widget getWidget( void );
	virtual void handleActivated( void );
};


#endif  /* _VDACTIONBUTTON_HXX */

