#ifndef _VDARC_HXX
#define _VDARC_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdArc.hxx                                         *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdArc;

/******************    dependences    *********************/

#include <Vd/VdPicture.hxx>
#include <Vd/VdPoint.hxx>

 
class VdArc : public VdPicture 
{
     int alpha, beta;
     VdPoint centre;
     int a, b;

  public : 

     VdArc( const VdPoint & center  = VdNullPoint, 
            int     aa      = 1,              // Hauptscheitel         
            int     bb      = 1,              // Nebenscheitel      
            int     alfa1   = 0,              // Winkel bzgl. pos. Achse 
            int     beta1   = 360,            // Winkel des Bogens 
            char    grad    = 'g'             // Masseinheit der Winkel 
          ); 

     VdPicture * duplicate(void);

     void setStartPoint( const VdPoint & p );
     void setEndPoint  ( const VdPoint & p );
     void setCentre    ( const VdPoint & p );
     void setAlpha     ( int a , char grad = 'g' );
     void setBeta      ( int b , char grad = 'g' );
     void setAxisA     ( int aa );
     void setAxisB     ( int bb );

     VdPoint    getStartPoint ( void ) const;
     VdPoint    getEndPoint   ( void ) const; 
     VdPoint    getCentre     ( void ) const;
     int        getAlpha      ( char grad = 'g' ) const;
     int        getBeta       ( char grad = 'g' ) const;
     int        getAxisA      ( void ) const; 
     int        getAxisB      ( void ) const; 

     virtual void prepare ( void );
 
     virtual void computeFrame ( void );

     virtual void draw( VdGeometricContext * G
                      , VdGraphicAttributes GA
                      );
     virtual void printPostScript(FILE* f);
     virtual void  print( int );

};

#endif /* _VDARC_HXX */
