#define _VDCASCADEOPTIONS_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdCascadeMenu.cxx                                 *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdCascadeMenu.hxx>
#include <Vd/VdPopupMenu.hxx>
#include <X11/Intrinsic.h>

#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/ToggleBG.h>
#include <Xm/CascadeB.h>

extern "C" {
#include <stdio.h>
}

VdPopupMenu *VdCascadeMenu::callingPopup;

void VdCascadeMenu::entryCB(Widget widget,
		XtPointer clientData, 
		XmRowColumnCallbackStruct * callData )
{
	// This callback does not know it's object (like
	// motifCB in the base class), the cascadingCallback
	// of the parent popup menu should set the popup
	// pointer
	if (callingPopup) 
	    callingPopup->handleLeave();
	// execute callback for button
	motifCB(callData->widget, 
		(XtPointer)(callData->data), 
		(XtPointer)(callData->callbackstruct));
}

VdCascadeMenu::VdCascadeMenu( Widget parent,
		VdFeature & window,
		VdEvent & event,
		VdSelectedHandles & selectedHandles)
{
	int i;
	Arg al[10];
	Cardinal ac;
	theParent = parent;
	theWindow = window;
	theEvent = &event;
	thePicture = selectedHandles.thePicture;
	XtCallbackRec cbList[2];
	cbList[0].callback = (XtCallbackProc)&entryCB;
	cbList[0].closure = 0;
	cbList[1].callback = NULL;
	cbList[1].closure = 0;

	ac=0;
	XtSetArg(al[ac], XmNentryCallback, cbList); 
	ac++; // settable only via create
	menuPane = XmCreatePulldownMenu(parent,
			"VisamadCascade",al,ac);
	for (i=1; i<!selectedHandles.handles; i++)
		addButton(selectedHandles.handles[i]);
	watchDestroying(menuPane);
}

void VdCascadeMenu::setPopup(VdPopupMenu * popup)
{
	callingPopup = popup;
}

VdCascadeMenu::~VdCascadeMenu( void )
{
#ifdef TEST_JH
	fprintf(stderr,"VdCascadeMenu::~VdCascadeMenu\n");
#endif
	callingPopup = NULL;
}

Widget VdCascadeMenu::getWidget( void )
{
	return menuPane;
}

void VdCascadeMenu::addButton( VdHandle * handle)
{
	VdActionButton * aButton;
	
	aButton =  new VdActionButton( 
			menuPane,
			theWindow,
			theEvent,
			handle,
			thePicture);
	addCB(aButton->getWidget(),activated);
}

void VdCascadeMenu::handleActivated( void )
{
	if (callingPopup)
		callingPopup->handleActivated();
}

#undef _VDCASCADEMENU_CXX
