#ifndef _VDCASCADEMENU_HXX
#define _VDCASCADEMENU_HXX

/***********************************************************
*                  VISAMAD.defgraph                        *
*              ==========================                  *
*  File: VdCascadeMenu.hxx                                 *
*  Date: 18-01-93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*  experimental declaration of class VdCascadeMenu:        *
*     An CascadeMenu object will be created dynamically    *
*     and will exist only during the live of the calling   *
*     menu.                                                *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdCascadeMenu;

/******************    dependences    *********************/

#include <Vd/VdActionButton.hxx>
#include <Vd/VdHandlePtrList.hxx>
#include <Vd/VdSelectedHandles.hxx>
#include <Vd/VdStringList.hxx>
#include <Vd/VdDestruction.hxx>

class VdPopupMenu;

class VdCascadeMenu: public VdCBmanager, 
		     public VdDestruction {

	Widget theParent;
	VdFeature theWindow;
	Widget menuPane;
	VdEvent * theEvent;
	VdPicture *thePicture;
	static VdPopupMenu *callingPopup;
	
	static void entryCB(Widget widget,
		XtPointer clientData, 
		XmRowColumnCallbackStruct * callData );
	// callback is defined here exceptionally
	// because entryCallback can not attached
	// via the normal way (only via create!)
	void addButton( VdHandle * handle );
   protected:
	~VdCascadeMenu( void );
   public:
	VdCascadeMenu( Widget parent,
		VdFeature & window,
		VdEvent & event,
		VdSelectedHandles & selectedHandles);

	Widget getWidget( void );
	void setPopup(VdPopupMenu * popup);
	virtual void handleActivated( void );
};


#endif  /* _VDCASCADEMENU_HXX */

