#ifndef _VDCOLOR_HXX
#define _VDCOLOR_HXX
 
/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdColor.hxx                                       *
*  Date: 27-01-93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Benary, B. Miethig, J. Hutschenreiter        *
*  State of Realization:  experimental version             *
************************************************************
*                                                          *
*     Definition of classes                                *
*        VdColor                                           *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdColor;

/******************    dependences    *********************/
 
class VdColor{
public:
        int code;
        static int MaxColors;
        static int Highlight;
        static int ColorPattern;

  friend void InitGraphicAttributes(Display *dp);

  VdColor(void) { code = -1; }                // VdCOLORUNDEF
  VdColor(int c) { code = c; }                // for internal use
  int Code(void) const; 


  VdColor operator+(void) const;                 // an
  VdColor operator-(void) const;                 // aus
  VdColor operator!(void) const;                 // umschalten


  VdColor dark(void) const;                      // dunkler
  VdColor middle(void) const;                    // mittel
  VdColor light(void) const;                     // heller


  VdColor operator+(const VdColor & c) const;    // oder
  VdColor operator-(const VdColor & c) const;    // und
  VdColor operator*(const VdColor & c) const;    // exklusiv oder


  int operator==(const VdColor & c) const;
  int operator!=(const VdColor & c) const;
};

/************************** constants **************************/

extern  const VdColor  
		      VdBLACK,
                      VdBROWN,
                      VdGRAY, VdGREY,
                      VdAZURE,
                      VdOLIVE,
                      VdTURQUOISE,
                      VdGREEN,
                      VdBLUE,
                      VdPURPLE,
                      VdVIOLETT, VdMAGENTA,
                      VdPINK,
                      VdRED,
                      VdORANGE,
                      VdGOLD,
                      VdYELLOW,
                      VdWHITE,
                      VdCOLORUNDEF ;


#endif  /* _VDCOLOR_HXX */
