#define _VDCONSISTENCE_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdConsistence.cxx                                 *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdConsistence.hxx>

typedef void * voidPtr;

#define VdListClassName VdvoidPtrList
#define VdListClassElementType voidPtr
#include <Vd/VdListDeclaration.mxx>
#include <Vd/VdListDefinition.mxx>
#undef VdListClassName
#undef VdListClassElementType

/*
#define VdListClassName VdReplaceFncPtrList
#define VdListClassElementType VdReplaceFncPtr
#include <Vd/VdListDeclaration.mxx>
#include <Vd/VdListDefinition.mxx>
#undef VdListClassName
#undef VdListClassElementType
*/

static VdvoidPtrList oldPtr, newPtr,
                     where, oldval, env;
//static VdReplaceFncPtrList method;
static VdvoidPtrList  method;

void VdConsistence::activate ( void )
{ if (!(handlingIsActive++))
  { oldPtr.reset();
    where.reset();
  }
}

void VdConsistence::registerInstance
                     ( void * PtrToOldInstance
                     , void * PtrToNewInstance
                     )
{ if (handlingIsActive)
  { int i = !oldPtr;
    oldPtr[i]=PtrToOldInstance;
    newPtr[i]=PtrToNewInstance;
  }
}

void VdConsistence::registerReplacement
                          ( void * Location
                          , void * PtrToOldInstance
                          , void * PtrToEnvironment
                          , VdReplaceFncPtr Method
                          )
{ if (handlingIsActive)
  { int i = !where;
    where[i]=Location;
    oldval[i]=PtrToOldInstance;
    env[i]=PtrToEnvironment;
    method[i]=(void*)Method;
  }
}

void VdConsistence::make ( void )
{ VdReplaceFncPtr Method;
  if (--handlingIsActive) return;
  { int i, j;
    for (i=0; i<!where; i++)
    { j=oldPtr.idx(oldval[i]);
      Method=(VdReplaceFncPtr)((void*)(method[i]));
      if (j<0) (Method)(where[i],oldval[i],env[i],0);
      else     (Method)(where[i],newPtr[j],env[i],1);
    }
    handlingIsActive=0;
  }
}

#undef _VDCONSISTENCE_CXX
