#ifndef _VDCONSISTENCE_HXX
#define _VDCONSISTENCE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdConsistence.hxx                                 *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdConsistence;

/******************    dependences    *********************/

typedef void (*VdReplaceFncPtr)(void*,void*,void*,int);


class VdConsistence{

  static int handlingIsActive;

public :

  static void activate ( void );

  static void registerInstance
            ( void * PtrToOldInstance
            , void * PtrToNewInstance
            );

  static void registerReplacement
            ( void * Location
            , void * PtrToOldInstance
            , void * PtrToEnvironment
            , VdReplaceFncPtr Method
            );

  static void make ( void );

};

/******************      constant     *********************/

#ifdef _VDCONSISTENCE_CXX

  int VdConsistence::handlingIsActive=0;

#endif

#endif /* _VDCONSISTENCE_HXX */
