#define _VDDECORATEDMAGNIFIERWINDOW_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdDecoratedMagnifierWindow.cxx                    *
*  Date: 30-10-92                                          *
*  Copyright (c) 1992                                       *
*  Technical University Dresden, Department of Mathematics *
*  Author: B. Miethig                                      *
*  State of Realization:  experimental version             *
************************************************************
*                                                          *
*     Implementation of class VdMagnifierWindow:           *
*                                                          *
*     Interface                                            *
*          VdDecoratedMagnifierWindow.hxx                  *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdMagnifierWindow.hxx>
#include <Vd/VdButton.hxx>
#include <Vd/VdDecoratedMagnifierWindow.hxx>
#include <Vd/VdAbstractWindow.hxx>


VdDecoratedMagnifierWindow::VdDecoratedMagnifierWindow(
	VdShell &shell, Boolean withScrollbars):
		VdMagnifierWindow(shell,withScrollbars)
	{
		installExitButton(Vd_Default) ;
	 	installModeButton() ;
		installWindowButton() ;
	}

VdButton * VdDecoratedMagnifierWindow::addEditWindowButton( 
				const VdFeature & ident ) 
	{
	if (!windowButtonPtr) return 0;
	VdFeature * id = new VdFeature(ident);
	addWindowButtonEntry( *id );
	// tricky!
	return (VdButton *) (void *)  id;
	}

void VdDecoratedMagnifierWindow::removeEditWindowButton(
				 VdButton * button ) 
	{
	if (!windowButtonPtr) return;
	VdFeature *id = (VdFeature *) (void *) button;
	if (!id) return;
	removeWindowButtonEntry( *id );
	delete id;
	} ;

VdButton * VdDecoratedMagnifierWindow::renameEditWindowButton( 
		VdButton * button,
		const VdFeature & ident )
{
	if (!windowButtonPtr) return button;
	VdFeature *id = (VdFeature *) (void *) button;
	if (!id) return button;
	renameWindowButtonEntry(
	    id->getString().charptr(),
	    ident.getString().charptr()
	);
	delete id;
	return (VdButton *) (void *)  new VdFeature(ident);
}


#undef _VDDECORATEDMAGNIFIERWINDOW_CXX
