#define _VDDESTRUCTION_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdDestruction.cxx                                 *
*  Date: 06-10-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
*                                                          *
************************************************************
*                                                          *
*     experimental declaration of class VdDestruction:     *
*        VdDestruction is a (virtual) base class for all   *
*        classes which contain widgets, if they have to    * 
*        watch destroying the widgets.                     *
*        Writing a own method 'destroy' the                *
*        programmer can garantee that an object is         *
*        handled well if the contained widgets are         * 
*        destroyed by the window manager or by top down    *
*        destroying of higher level widgets.               *
*                                                          *
*     Interface                                            *
*        VdDestruction.hxx, X11/Intrinsic.h, Xm/Xm.h       *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdDestruction.hxx>

#include <X11/Intrinsic.h>
#include <Xm/Xm.h>

#include <strstream.h>

// default constructor inline

VdDestruction::~VdDestruction( void ) 
{ 
}

void VdDestruction::destroyCB(Widget widget, 
		XtPointer clientData, XtPointer callData )
{
	VdDestruction *object = (VdDestruction *)clientData;
	delete object; 
}

void VdDestruction::watchDestroying(Widget widget)
{
	XtAddCallback(widget, 
		XmNdestroyCallback, 
		(XtCallbackProc)&destroyCB, 
		(XtPointer)this );
}

#undef _VDDESTRUCTION_CXX
