#ifndef _VDDOT_HXX
#define _VDDOT_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdDot.hxx                                         *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdDot;

/******************    dependences    *********************/

#include <Vd/VdPicture.hxx>
#include <Vd/VdPoint.hxx>

class VdDot : public VdPicture{

  VdPoint dot;

  public : 
 

      VdDot ( const VdPoint & p = VdNullPoint ); 
      VdDot ( int x, int y ); 

      VdPicture * duplicate(void);

      void setDot ( const VdPoint & p );
      void setDot ( int x, int y );

      VdPoint getDot ( void );

      virtual void prepare ( void );

      virtual void computeFrame ( void );

      virtual void draw ( VdGeometricContext * G
                        , VdGraphicAttributes GA
                        ) ; 
     virtual void printPostScript(FILE* f);
      virtual void print( int );
};  

#endif /* _VDDOT_HXX */
