#ifndef _VDEDITWINDOW_HXX
#define _VDEDITWINDOW_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdEditWindow.hxx                                  *
*  Date: 06-10-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization:  experimental version             *
************************************************************
*                                                          *
*     Declaration of class VdEdiWindow                     *
*          An EditWindow can draw pictures and initiate    *
*          handling of keybord and mouse events.           *
*          It can be connected with an Magnifier Window    *
*          to get a better overview of the displayed       *
*          picture.                                        *
*                                                          *
*     Interface                                            *
*          VdAbstractWindow.hxx, VdEventManagerInterface   *
*                                                          *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdEditWindow;

/******************    dependences    *********************/

#include <Vd/VdAbstractWindow.hxx>
#include <Vd/VdEventHandling.hxx>

class VdWindowConnection;
class VdEventManagerInterface;

#include <Vd/VdEventManagerInterface.hxx>

class VdEditWindow : public VdAbstractWindow {
// inheritance should be virtual but OASYS translator 
// contains an error generating virtual function tables
// for twice virtual public inheritances

   friend class VdWindowConnection;

	VdWindowConnection *theConnection;
	VdAllSelectedHandles handleList;
	VdEventManagerInterface *theEventInterface;

	void initiateEventHandling( VdEvent *ev );
	VdFeature setConnection( VdWindowConnection *wc, 
		       VdFeature& prefix );

   protected:
	VdWindowConnection *getConnection( void );

   public:
        VdEditWindow( VdShell &shell,
                Boolean withScrollbars = True);
        ~VdEditWindow( void );

	void setEventManagerInterface(
		VdEventManagerInterface *interface);
	VdEventManagerInterface *
		getEventManagerInterface( void );

	virtual void handleDestroyed( void );
	virtual void handleButtonPressed( VdEvent* ev );
	virtual void handleButtonReleased( VdEvent* ev );
	virtual void handleKeyPressed( VdEvent* ev );
	virtual void handleResized( void );
	virtual void handleHoriValueChanged( void );
	virtual void handleVertValueChanged( void );
	virtual void handleHelp( void );
};

#endif  /* _VDEDITWINDOW_HXX */
