#ifndef _VDEVENT_HXX
#define _VDEVENT_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdEvent.hxx                                       *
*  Date: 31-10-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Benary, J. Hutschenreiter                    *
*  State of Realization: experimental version              *
*                                                          *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdEvent;

/******************    dependences    *********************/

#include <Vd/VdFeature.hxx>
#include <Vd/VdPoint.hxx>
#include <Vd/VdPicture.hxx>

#define Vd_SHIFT_STATE 		1
// all shift keys and caps lock
#define Vd_CONTROL_STATE 	2
#define Vd_ALT_STATE 		4
#define Vd_ALT_GR_STATE		8
#define Vd_ALL_MODIFIER_KEYS	\
  (Vd_SHIFT_STATE \
  |Vd_CONTROL_STATE \
  |Vd_ALT_STATE \
  |Vd_ALT_GR_STATE)
// all mode switches
#define Vd_FUNCTION_KEY		16
// F1 ... F35 are possible
#define Vd_SPECIAL_KEY		32
// Select, Print, Execute, Insert, Undo, Redo, Menu, Find, 
// Cancel, Help; beginning with keyCode==0
#define Vd_CURSOR_KEY		64
//Home,Left,Up,Right,Down,Prior,Next,End,Begin
#define Vd_KEYPAD_KEY		128
//Space, Tab,Enter,F1,F2,F3,F4,Equal,Multiply,Add
//Seperator,Subtract,Decimal,Divide,0..9

class VdEvent{

 public:

  VdFeature type;   // event prefix and kind of event
  VdFeature window; // the window where event happened
  VdPicture* theEntirePicture; // the Picture of the window
  VdPoint location; // world coordinates at window level
  int keyCode;      // ASCII
  int statusCode;
  unsigned int XKeyNum;
  unsigned int XKeyState;  
};

#endif /* _VDEVENT_HXX */
