#define _VDEVENTHANDLING_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdEventHandling.cxx                               *
*  Date: 31-10-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Benary, J. Hutschenreiter                    *
*  State of Realization: experimental version              *
*                                                          *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdEvent.hxx>
#include <Vd/VdHandle.hxx>
#include <Vd/VdHandlePtrList.hxx>
#include <Vd/VdSelectedHandles.hxx>
#include <Vd/VdSelectedHandlesList.hxx>
#include <Vd/VdAllSelectedHandles.hxx>
#include <Vd/VdPicture.hxx>


void VdHandle::addPicture ( VdPicture * p )
{ if (insertedIn.idx(p)<0) insertedIn.ins()=p;
}

void VdHandle::remPicture ( VdPicture * p )
{ insertedIn.rem(insertedIn.idx(p));
}

void VdHandle::clearPicture ( void )
{ int i;
  for (i=0; i<!insertedIn; i++)
    insertedIn[i]->remHandle(this);
}

VdHandle::VdHandle(void)
: type("*")
{}

VdHandle::VdHandle( VdHandle & h )
: type(h.type), name(h.name)
{ VdConsistence::registerInstance(&h,this);
}

VdHandle::~VdHandle(void)
{ clearPicture();
}

int VdHandle::test ( VdEvent * theEvent
                   , VdPicture * thePicture
                   )
{ return (   ( (theEvent->location) < (thePicture->getAbsFrame())
             )
           &&
             ( type == theEvent->type )
         );
}

void VdHandle::enter ( VdEvent * theEvent
                     , VdPicture * thePicture )
{ thePicture->setForeground(!(thePicture->getForeground()));
}

void VdHandle::leave ( VdEvent * theEvent
                     , VdPicture * thePicture )
{ thePicture->setForeground(!(thePicture->getForeground()));
}

void VdHandle::execute ( VdEvent * theEvent
                       , VdPicture * thePicture )
{  thePicture->setForeground(!(thePicture->getForeground()));
}

#define VdListClassName VdHandlePtrList
#define VdListClassElementType VdHandle*
#include <Vd/VdListDefinition.mxx>
#undef VdListClassName
#undef VdListClassElementType

int VdSelectedHandles::operator==( const VdSelectedHandles & x ) const
{ return this == &x;
}

int VdSelectedHandles::operator!=( const VdSelectedHandles & x ) const
{ return this != &x;
}


#define VdListClassName VdSelectedHandlesList
#define VdListClassElementType VdSelectedHandles
#include <Vd/VdListDefinition.mxx>
#undef VdListClassName
#undef VdListClassElementType

#undef _VDEVENTHANDLING_CXX
