#define _VDEVENTMANAGERINTERFACE_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdEventManagerInterface.hxx                       *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdEventManagerInterface.hxx>
#include <Vd/VdPopupMenuInterface.hxx>
#include <Vd/VdSelectionHandle.hxx>

#define VdListClassName VdSelectionHandlePtrList
#define VdListClassElementType VdSelectionHandle*
#include <Vd/VdListDeclaration.mxx>
#include <Vd/VdListDefinition.mxx>
#undef VdListClassName
#undef VdListClassElementType

static VdSelectionHandlePtrList selectionPtrs;

void VdEventManagerInterface::handleEvent
           ( VdWindowManagerInterface * theManager
           , VdAllSelectedHandles * theList
           )
{ if( !(theList->selections) == 0 ) return;
  if(   (!(theList->selections) == 1 )
     && (!(theList->selections[0].handles)==1)
    )
  { VdSelectedHandles & href = theList->selections[0];
    href.handles[0]->execute( & (theList->theEvent) , href.thePicture );
    theManager->redrawPicture( theList->theEntirePicture );
    return;
  }
  int i;
  if (!(theList->selections)>!selectionPtrs)
    for (i=!selectionPtrs; i<!(theList->selections); i++)
      selectionPtrs.ins()=new VdSelectionHandle;
  for (i=0; i<!(theList->selections); i++)
  { VdSelectedHandles & href = theList->selections[i];
    selectionPtrs[i]->name=href.thePicture->getSelectionIdentifier();
    href.handles.ins(0)=selectionPtrs[i];
  }
  VdPopupMenuInterface * menu = new VdPopupMenuInterface;
  menu->isMultiple=0;
  menu->selectedHandles=theList;
  theManager->createAndHandleMenu(menu);
}
  
const VdFeature & VdEventManagerInterface::getEventPrefix( void ) const
{ return Prefix;
}

#undef _VDEVENTMANAGERINTERFACE_CXX
