#ifndef _VDFEATURE_HXX
#define _VDFEATURE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdFeature.hxx                                     *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdFeature;

/******************    dependences    *********************/

#include <Vd/VdStringList.hxx>

class VdFeature{
  static VdStringList Identifier;
  short * pattern;                      // Codierungsfeld
  int CodeLength;                           // Laenge der Codierung

  enum VdFeatureCode{ ChCodeStar = -1,
                      ChCodeMark = -2,
                      ChCodeAltB = -3,
                      ChCodeAltS = -4,
                      ChCodeAltE = -5,
                      ChCodeEnd  = -6
                    };                  //Spezielle Codes

  static void AnaAlternate
                             ( char* & cp, short* &pp, int& l );
  static void AnaIdentifier
                             ( char* & cp, short* &pp, int& l );
  static void AnaAnalize
                             ( char* & cp, short* &pp, int& l );

  static short * CmpStep    ( short * p );
  static short * CmpNextAlt ( short * p );
  static short * CmpNext    ( short * p );
  static int     CmpCompare ( short * c1, short * c2 );

 public:

  VdFeature ( void );
  VdFeature ( const VdFeature & );
  VdFeature ( const VdString & );
  VdFeature ( char * );
  ~VdFeature (void) { delete pattern; }
  
  int operator! ( void ) const;                     //Laenge
  int length    ( void ) const;                     //Laenge
  VdFeature operator+ ( const VdFeature & ) const;  //Verkettung
  void removeLast ( int n = 1 );                    //Verkuerzung
  VdFeature getLast( int n = 1 ) const;             // Feature - Rest
  VdFeature operator| ( const VdFeature & ) const;  //Alternative

  VdFeature & operator= ( const VdFeature & );
  VdFeature & operator+= ( const VdFeature & );
  VdFeature & operator|= ( const VdFeature & ); 

  int operator== ( const VdFeature & ) const;
  int operator!= ( const VdFeature & ) const;

  VdString getString( void ) const;

};

/******************     constants     *********************/ 

#ifdef _VDFEATURE_CXX
/* This static memeber is declared in module VdPrecariosConstants
   in order to ensure the correct initialization sequence of objects:
   VdStringList VdFeature::Identifier;
*/

#endif

#endif /* _VDFEATURE_HXX */
