#ifndef _VDFILLEDRECTANGLE_HXX
#define _VDFILLEDRECTANGLE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdFilledRectangle.hxx                             *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdFilledRectangle;

/******************    dependences    *********************/

#include <Vd/VdPicture.hxx>
#include <Vd/VdArea.hxx>


class VdFilledRectangle : public VdPicture{ 

      VdArea rectangle;
 

  public : 

     VdFilledRectangle( const VdPoint & p1 = VdNullPoint
                      , const VdPoint & p2 = VdNullPoint
                      ); 
     VdFilledRectangle( const VdPoint & p1
                      , int width, int height
                      ); 
     VdFilledRectangle( const VdArea & a );
 
     VdPicture * duplicate(void);

     void setRectangle( const VdPoint & p1 = VdNullPoint, 
                        const VdPoint & p2 = VdNullPoint
                      );
     void setRectangle( const VdPoint & p1 , 
                        int width, int height
                      );
     void setRectangle( const VdArea & a );

     VdArea getRectangle ( void ) const;

     virtual void prepare ( void );

     virtual void computeFrame ( void );

     virtual void draw( VdGeometricContext * G
                      , VdGraphicAttributes GA 
                      ); 

     virtual void printPostScript(FILE* f);
      virtual void print( int );
}; 

#endif /* _VDFILLEDRECTANGLE_HXX */
