#define _VDFORMULAR_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: filename.cxx                                      *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdFormular.hxx>
#include <Vd/VdGlobalFunctions.hxx>
#include <Vd/VdShell.hxx>
#include <Vd/VdFormularEntry.hxx>
#include <Vd/VdFormularInformation.hxx>
#include <Vd/VdFormularInput.hxx>
#include <Vd/VdFormularTitle.hxx>
#include <Vd/VdFormularRadioBox.hxx>
#include <Vd/VdFormularCheckBox.hxx>
#include <Vd/VdToggleList.hxx>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/Form.h>
#include <Xm/PushBG.h>
#include <Xm/Label.h>
#include <Xm/Text.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/BulletinB.h>
#include <Xm/MwmUtil.h>

extern "C" {
#include <stdio.h>
}

static char *visamadFormular="VisamadFormular";
static VdFeature dummy("");

VdFormular::VdFormular( VdFormularInterface * interface )
{
	Arg al[20];
	Cardinal ac, ac0;
	int i;
	Widget aText, aLabel, aBox, aBox2;
	VdToggleList * aToggleList;
	InputField * inputFieldPtr = inputFields;

	theInterfacePtr = interface;
	theEntryListPtr = &(interface->entries);
	nrInputFields = 0;

	Dimension textWidth=0; 

	ac = 0;
	XtSetArg(al[ac],XmNtitle,visamadFormular); 
	ac++;
        XtSetArg(al[ac], XmNtransientFor, VdGetActiveShell());
	ac++;
	XtSetArg(al[ac], XmNtitle, 
		(theInterfacePtr->formularName).charptr());
	ac++;
	XtSetValues(VdShell::theDialogShell,al,ac);

	ac = 0;
	XtSetArg(al[ac], XmNdialogStyle,
		XmDIALOG_APPLICATION_MODAL); ac++;
	XtSetArg(al[ac], XmNautoUnmanage, False); ac++;
        XtSetArg(al[ac], XmNdefaultPosition, False); ac++;
	theFormular = XmCreateForm( 
		VdShell::theDialogShell,visamadFormular,al,ac);

	if (theEntryListPtr) {
	  for (i=0; i<!(*theEntryListPtr) && i<32; i++) {
	    VdFormularEntry * entry = (*theEntryListPtr)[i];
	    ac = 0;
	    if (i==0) {
	      XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM );
	      ac++;
	    } else {
	      XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET );
	      ac++;
	      XtSetArg(al[ac], XmNtopWidget, theForms[i-1] );
	      ac++;
	    }
	    XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM );
	    ac++;
	    XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM );
	    ac++;
	    switch (entry->type) {
		case VdFormularEntry::Title:
			XtSetArg(al[ac], XmNalignment, XmALIGNMENT_CENTER);
			ac++;
			theForms[i] = XmCreateLabel(theFormular,
				(entry->name).charptr(),al,ac);
			break;
		case VdFormularEntry::Information:  // Text readonly
		case VdFormularEntry::Input:
			theForms[i] = XmCreateForm(theFormular,
				visamadFormular,al,ac);
			ac = 0;
			XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM );
			ac++;
			XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM );  
			ac++;
			XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM ); 
			ac++;
			XtSetArg(al[ac], XmNcolumns, theInterfacePtr->charWidth); 
			ac++;  
			if ( entry->type == 
				VdFormularEntry::Information) {
			 XtSetArg(al[ac], XmNrows, 
			  ( (VdFormularInformation *) entry )
			    ->line);
			} else {
			 XtSetArg(al[ac], XmNrows, 
			  ( (VdFormularInput *) entry )
			    ->line);
			}
			ac++; 
			XtSetArg(al[ac], XmNeditMode, XmMULTI_LINE_EDIT); 
			ac++;
			if ( entry->type == 
				VdFormularEntry::Information) {
			 XtSetArg(al[ac], XmNvalue, 
			  (( (VdFormularInformation *) entry )
			    ->contents).charptr());
			} else {
			 XtSetArg(al[ac], XmNvalue, 
			  (( (VdFormularInput *) entry )
			    ->contents).charptr());
			}
			ac++; 
			if ( entry->type == 
				VdFormularEntry::Information) {
			  XtSetArg(al[ac], XmNeditable, False); 
			  ac++; 
			}
			aText = XmCreateText(theForms[i],
				visamadFormular,al,ac);
			XtManageChild(aText);
			if (textWidth==0) {
			  ac=0;
			  XtSetArg(al[ac], XmNwidth, &textWidth);
			  ac++;
			  XtGetValues(aText, al, ac);
			}
			if ( entry->type == 
				VdFormularEntry::Input) {
				nrInputFields++;
				inputFieldPtr->text = aText;
				inputFieldPtr->entryNr = i;
				inputFieldPtr++;
			}

			ac = 0;
			XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM );  
			ac++;
			XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM ); 
			ac++;
			XtSetArg(al[ac], XmNrightAttachment, XmATTACH_WIDGET );
			ac++;
			XtSetArg(al[ac], XmNrightWidget, aText );
			ac++;
			XtSetArg(al[ac], XmNalignment, XmALIGNMENT_BEGINNING);
			ac++;
			aLabel = XmCreateLabel(theForms[i],
				(entry->name).charptr(),al,ac);
			XtManageChild(aLabel);
			break;
		case VdFormularEntry::RadioBox:  
		case VdFormularEntry::CheckBox:
			theForms[i] = XmCreateForm(theFormular,
				visamadFormular,al,ac);
			if (textWidth==0) { 
			  // compute width if no text widget is created befor
			  ac=0;
			  XtSetArg(al[ac], XmNcolumns, 
				theInterfacePtr->charWidth); 
			  ac++;  
			  aText = XmCreateText(theFormular,
				visamadFormular,al,ac);
			  ac=0;
			  XtSetArg(al[ac], XmNwidth, &textWidth);
			  ac++;
			  XtGetValues(aText, al, ac);
			  XtDestroyWidget(aText);
			}
			ac = 0;
			XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM );
			ac++;
			XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM );  
			ac++;
			XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM );  
			ac++;
			XtSetArg(al[ac], XmNshadowThickness, 2); 
			ac++;
			XtSetArg(al[ac], XmNshadowType, XmSHADOW_IN);
			ac++;
			XtSetArg(al[ac], XmNwidth, textWidth-2 );
			ac++;
			XtSetArg(al[ac], XmNfractionBase, textWidth-2 );
			ac++;
			aBox = XmCreateForm(theForms[i],
				visamadFormular,al,ac);

			ac = 0;
			XtSetArg(al[ac], XmNtopAttachment, XmATTACH_POSITION );
			ac++;
			XtSetArg(al[ac], XmNtopPosition, 5);
			ac++;
			XtSetArg(al[ac], XmNleftAttachment, XmATTACH_POSITION );  
			ac++;
			XtSetArg(al[ac], XmNleftPosition, 5);
			ac++;
			XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_POSITION );  
			ac++;
			XtSetArg(al[ac], XmNbottomPosition, textWidth-5);
			ac++;
			if ( entry->type == 
				VdFormularEntry::RadioBox) {
			 XtSetArg(al[ac], XmNradioBehavior, True); ac++;
		         XtSetArg(al[ac], XmNradioAlwaysOne, True); ac++; 
			} else {
			 XtSetArg(al[ac], XmNradioBehavior, False); ac++;
			}
			aBox2 = XmCreateRadioBox(aBox,
					visamadFormular,al,ac);

			if ( entry->type == 
				VdFormularEntry::RadioBox) {
			  aToggleList = 
			    new VdToggleList( aBox2, 
				&dummy,
				(VdButtonInterface *) (
				  (VdFormularRadioBox *) entry),
				1,
				((VdFormularRadioBox *)
				   entry)->mask );
			} else {
			  aToggleList = 
			    new VdToggleList( aBox2, 
				&dummy,
				(VdButtonInterface *) (
				  (VdFormularCheckBox *) entry),
				0,
				((VdFormularCheckBox *)
				   entry)->mask );
			}
			XtManageChild(aBox2);
			XtManageChild(aBox);

			ac = 0;
			XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM );  
			ac++;
			XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM ); 
			ac++;
			XtSetArg(al[ac], XmNrightAttachment, XmATTACH_WIDGET );
			ac++;
			XtSetArg(al[ac], XmNrightWidget, aBox );
			ac++;
			XtSetArg(al[ac], XmNalignment, XmALIGNMENT_BEGINNING);
			ac++;
			aLabel = XmCreateLabel(theForms[i],
				(entry->name).charptr(),al,ac);
			XtManageChild(aLabel);
			break;
	    }
	    XtManageChild(theForms[i]);
	  }
	}
	
	ac = 0;
	if (!(*theEntryListPtr)==0) {
	      XtSetArg(al[ac], XmNtopAttachment, XmATTACH_FORM );
	      ac++;
	} else {
	      XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET );
	      ac++;
	      XtSetArg(al[ac], XmNtopWidget, theForms[!(*theEntryListPtr)-1] );
	      ac++;
	}
	Widget separator;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM ); 
	ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM );
	ac++;
	XtSetArg(al[ac], XmNorientation, XmHORIZONTAL); ac++;
	XtSetArg(al[ac], XmNheight, 10); ac++;
	separator = XmCreateSeparatorGadget(theFormular,
		visamadFormular,al,ac);
	XtManageChild(separator);

	ac=0;
	XtSetArg(al[ac], XmNtopAttachment, XmATTACH_WIDGET );
	ac++;
	XtSetArg(al[ac], XmNtopWidget, separator );
	ac++;
	XtSetArg(al[ac], XmNalignment, XmALIGNMENT_CENTER);
	ac++;
	XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM );  
	ac++;

	ac0 = ac;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_FORM ); 
	ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION );
	ac++;
	XtSetArg(al[ac], XmNrightPosition, 20);
	ac++;
	okButton = XmCreatePushButtonGadget(
		theFormular,"OK",al,ac);
	XtManageChild(okButton);
	addCB(okButton,activated);
	ac = ac0;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_POSITION ); 
	ac++;
	XtSetArg(al[ac], XmNleftPosition, 40);
	ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_POSITION );
	ac++;
	XtSetArg(al[ac], XmNrightPosition, 60);
	ac++;
	testButton = XmCreatePushButtonGadget(
		theFormular,"Test",al,ac);
	XtManageChild(testButton);
	addCB(testButton,activated);
	ac = ac0;
	XtSetArg(al[ac], XmNleftAttachment, XmATTACH_POSITION ); 
	ac++;
	XtSetArg(al[ac], XmNleftPosition, 80);
	ac++;
	XtSetArg(al[ac], XmNrightAttachment, XmATTACH_FORM );
	ac++;
	cancelButton = XmCreatePushButtonGadget(
		theFormular,"Cancel",al,ac);
	XtManageChild(cancelButton);
	addCB(cancelButton,activated);

}

VdFormular::~VdFormular( void )
{
	XtUnmanageChild(theFormular);
	XtDestroyWidget(theFormular);
}

void VdFormular::map ( void )
{
	stopFlag = 0;
        XtManageChild(theFormular);
}


void VdFormular::handleActivated( void )
{
	int i;
	InputField * inputFieldPtr = inputFields;
	int nrMisspelledEntries=0;
	Widget aText;
	String textString;
	VdFormularInput * entryPtr;

	for (i=0; i<nrInputFields; i++,inputFieldPtr++) {
		aText = inputFieldPtr->text;
		textString = XmTextGetString(aText);
		entryPtr = (VdFormularInput *)
			(*theEntryListPtr)[inputFieldPtr->entryNr];
		inputFieldPtr->errorPos = 
			entryPtr->setAndTestContents( textString );
		if (inputFieldPtr->errorPos) nrMisspelledEntries++;
		XtFree(textString);
	}
	if (getLastWidgetOfEvent()==okButton) {
		if (!nrMisspelledEntries)  {
			for (i=0; i<!(*theEntryListPtr); i++) 
			  (*theEntryListPtr)[i]->
			    handleOkOrCancel(nrMisspelledEntries);
			stopFlag = 1;
			return; 
		}
	} else if (getLastWidgetOfEvent()==testButton) {
	} else if (getLastWidgetOfEvent()==cancelButton) {
		for (i=0; i<!(*theEntryListPtr); i++) 
		  (*theEntryListPtr)[i]->
		    handleOkOrCancel(nrMisspelledEntries); 
		stopFlag = 2;
		return;
	}

	inputFieldPtr = inputFields;
	for (i=0; i<nrInputFields; i++,inputFieldPtr++) {
		aText = inputFieldPtr->text;
		entryPtr = (VdFormularInput *)
			(*theEntryListPtr)[inputFieldPtr->entryNr];
		XmTextSetString(aText,(entryPtr->contents).charptr());
		XmTextSetHighlight(aText,0,
			XmTextGetLastPosition(aText),
			XmHIGHLIGHT_NORMAL);
		if (inputFieldPtr->errorPos) {
		   XmTextSetInsertionPosition(aText,
			inputFieldPtr->errorPos-1);
		   if (inputFieldPtr->errorPos > 
			(entryPtr->contents).length())
		      XmTextInsert(aText,
			(entryPtr->contents).length(),"...");
		   XmTextSetHighlight(aText,inputFieldPtr->errorPos-1,
			XmTextGetLastPosition(aText),
			XmHIGHLIGHT_SELECTED);
		}
	}
}  

Widget VdFormular::getWidget( void )
{
	return theFormular; 
}

int * VdFormular::getFlagPtr( void )
{
	return &stopFlag; // for localMainLoop
}

int VdFormular::wasCanceled( void )
{
	return stopFlag-1;
}

#undef _VDFORMULAR_CXX
