#ifndef _VDFORMULAR_HXX
#define _VDFORMULAR_HXX

/***********************************************************
*                     VISAMAD.defgraph                     *
*                ==========================                *
*  File: VdFormular.hxx                                    *
*  Date: 06-01-93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*  Comment                                                 *
*     experimental declaration of class VdFormular         *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdFormular;

/******************    dependences    *********************/

#include <Vd/VdFormularEntryPtrList.hxx>
#include <Vd/VdFormularInterface.hxx>
#include <Vd/VdCBmanager.hxx>

class VdFormular: virtual public VdCBmanager {
   private:
	VdFormular( void ); // not accessable
	VdFormularEntryPtrList * theEntryListPtr;
	VdFormularInterface *theInterfacePtr;
	int stopFlag;

   protected:
	Widget theFormular;
	Widget theForms[32];
	struct InputField { 
		Widget text; 
		int entryNr; 
		int errorPos; } inputFields[32];
	int nrInputFields;
	Widget  okButton, 
		cancelButton, testButton;

   public:
	VdFormular( VdFormularInterface * interface );
	~VdFormular( void );

	virtual void map( void );
	virtual void handleActivated( void );	
	Widget getWidget( void );
	int * getFlagPtr( void );
	int wasCanceled( void );
};


#endif  /* _VDFORMULAR_HXX */

