#define _VDFORMULARINPUT_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdFormularInput.cxx                               *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdFormularInput.hxx>

#ifdef _HXX_INCLUDE_
#include <string.hxx>
#else
#include <string.h>
#endif

VdFormularInput::VdFormularInput(int l )
{ isChanged=isMisspelled=0;
  line=l;
  type=VdFormularEntry::Input;
}

int VdFormularInput::setAndTestContents( char * s )
{ if (strcmp(s,contents.charptr()))
  { isChanged=1;
    contents=VdString(s);
  }
  isMisspelled=pattern.test(contents);
  return isMisspelled;
}

int VdFormularInput::setAndTestContents( const VdString & s )
{ if (s != contents)
  { isChanged=1;
    contents=s;
  }
  isMisspelled=pattern.test(contents);
  return isMisspelled;
}

int VdFormularInput::setTestAndMarkContents( char * s )
{ if (strcmp(s,contents.charptr()))
  { isChanged=1;
    contents=VdString(s);
  }
  isMisspelled=pattern.testAndMark(contents);
  return isMisspelled;
}

int VdFormularInput::setTestAndMarkContents( const VdString & s )
{ if (s != contents)
  { isChanged=1;
    contents=s;
  }
  isMisspelled=pattern.testAndMark(contents);
  return isMisspelled;
}

#undef _VDFORMULARINPUT_CXX
