#ifndef _VDFRACTNUMBER_HXX
#define _VDFRACTNUMBER_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdFractNumber.hxx                                 *
*  Date: 21-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*     This file defines:    class VdFractNumber            *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdFractNumber;

/******************    dependences    *********************/

class VdFractNumber
    {
     friend class VdGeometricContext ;


public:

     int denominator,numerator ;

//  constuctor

     VdFractNumber(int i=1, int j=1) ;
     VdFractNumber(double d);

//   methods

     float getFloatValue(void) const;
     // returns the float-value of the fractnumber

     double getDoubleValue(void) const;

     int getIntValue(void) const;
     // returns the biggest int-value
     // which is less than the fractnumber

     int getBestIntValue(void) const;

     int getDenominator(void) const {return denominator;}
	  // get the denominator

     void setDenominator(const int d);
	  // changes the denominator

     int getNumerator(void) const {return numerator;}
	  // get the numerator

     void setNumerator(const int n){numerator=n;}  
	  // changes the numerator

//   operators

  int operator > (const VdFractNumber &aFractNumber) const;

  int operator < (const VdFractNumber &aFractNumber) const;

  int operator <= (const VdFractNumber &aFractNumber) const;

  int operator >= (const VdFractNumber &aFractNumber) const;

  int operator == (const VdFractNumber &aFractNumber) const;
 
  VdFractNumber operator - (void) const;

  VdFractNumber operator + (
	       const VdFractNumber &aFractNumber
			   ) const;

  VdFractNumber operator - (
	       const VdFractNumber &aFractNumber
			   ) const;

  VdFractNumber operator * (
	       const VdFractNumber &aFractNumber
			   ) const;

  VdFractNumber operator / (
	       const VdFractNumber &aFractNumber
			   ) const;

  VdFractNumber half (void) const;
};

extern const VdFractNumber VdONE;
extern const VdFractNumber VdZERO;

#ifdef _VDFRACTNUMBER_CXX
  const VdFractNumber VdONE(1,1);
  const VdFractNumber VdZERO(0,1);
#endif

#endif /* _VDFRACTNUMBER_HXX */
