#ifndef _VDGLOBALFUNCTIONS_HXX
#define _VDGLOBALFUNCTIONS_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdGlobalFunctions.hxx                             *
*  Date: 07-04-93                                          *
*  Copyright (c) 1993                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization:  experimental version             *
************************************************************
*                                                          *
*     This modul contains global function which are        *
*     no methods of any classes                            *
*                                                          *
*     References:                                          *
* [XtRM] X Toolkit Intrinsics Reference Manual,            * 
*        Second Edition for X11 Release 4                  *
*        O'Reilly & Associates, Inc.                       *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

extern "C" {
#include <stdlib.h>
}

#include <Vd/VdString.hxx>
#include <Vd/VdStringList.hxx>
#include <Vd/VdShell.hxx>
#include <Vd/VdFormularInterface.hxx>

void VdLocalMainLoop(int * stopFlag);
	// processes all events until stopFlag is set
	// to 1 and returns

Widget VdGetActiveShell( void );
	// answers the shell widget with input focus or
	// the application shell

void VdSynchronize( void );
	// wait for processing of all hanging requests by
	// the application

int VdCreateAndHandleDecision(
		const VdString & dialogTitle,
		const VdString & messageText,
		VdStringList & buttonLabels);
	// opens a message boxand returns the number 
	// of the pressed button (0...n-1).
	// (the function uses localMainLoop)

int VdCreateAndHandleFileSelection(  const VdString & dialogTitle,
		 VdString & directory, 
		 VdString & fileName,
		 int filter);
	// opens a application modal file selection dialog and
	// returns 1 if a selection is done (0 if canceled).
	// If filter the fileName is used as pattern and 
	// directory as search directory otherwise
	// "*" is the pattern and the currenct directory is used.
	// if (!canceled) directory is the path of the selected
	// file (ending with '/') and fileName the file name 
	// without the path.

int VdCreateAndHandleFormular( 
		VdFormularInterface * interface);
	// opens a application modal formular dialog and
	// returns 1 if a selection is done (0 if canceled).

class VdPicture;
int VdPostScriptOriginal( VdString& filename
                        , VdPicture * picture
                        , VdPoint & lowerleft
                        );
	// writes on the file "filename" the PostScript description
	// of the picture "picture" using the world coordinates as
	// PostScript coordinates and locates the left lower corner
	// of the picture at the PostScript location lowerleft

int VdPostScriptA4( VdString& filename
                  , VdPicture * picture
                  );
	// writes on the file "filename" the PostScript description
	// of the picture "picture" with the PostScript size of (504,720)
        // rotating and scaling if necessary
        // and locates the left lower corner
	// of the picture at the PostScript location (39,55)

#endif  /* _VDGLOBALFUNCTIONS_HXX */
