#ifndef _VDGRAPHICATTRIBUTES_HXX
#define _VDGRAPHICATTRIBUTES_HXX
 
/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdGraphicAttributes.hxx                           *
*  Date: 04-11-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Benary, B. Miethig                           *
*  State of Realization:  experimental version             *
************************************************************
*                                                          *
*     Definition of classes                                *
*        VdGraphicAttributes                               *
*                                                          *
*     Interface                                            *
*            Xlib.h, VdVector.hxx                          *
***********************************************************/
 
/******************  defined classes  *********************/

class VdGraphicAttributes;

/******************    dependences    *********************/

#include <X11/Xlib.h> 
#include <Vd/VdVector.hxx>
#include <Vd/VdColor.hxx>
#include <Vd/VdFillType.hxx>
#include <Vd/VdLineType.hxx>
#include <Vd/VdArcType.hxx>
 
class VdGraphicAttributes{
  static int isInitialized ;
  Display * display; Drawable drawable;
  XGCValues values;
  unsigned long valuemask;
  GC gc; char newGC;
  VdVector fontSize;
  VdVector fontBias;
  Font fontID;

 public:

  enum VdDrawingFunctionType{
    VdDrawingFunctionCopy = GXcopy,
    VdDrawingFunctionXor  = GXxor
  };

  VdGraphicAttributes ( const VdGraphicAttributes & );
  VdGraphicAttributes ( Display *, Drawable );

  VdGraphicAttributes & operator= ( const VdGraphicAttributes & );

  void setForeground ( const VdColor & );
  void setBackground ( const VdColor & );
  void setLineType ( const VdLineType & );
  void setFillType ( const VdFillType & );
  void setArcType ( const VdArcType & );
  void setDrawingFunction ( VdDrawingFunctionType );
  void setFontSize(const VdVector &cell);
  VdVector getFontSize ( void );
  VdVector getBias( void );

#ifdef TEST_JH
  void printGC( void );
#endif

  Display* getDisplay  ( void ) const { return display; }
  Drawable getDrawable ( void ) const { return drawable; }
  void setDrawable ( Drawable d ) { drawable=d; }
  GC getGC ( void );
  Font getFontID( void );

  ~VdGraphicAttributes ( void );
};

#endif  /* _VDGRAPHICATTRIBUTES_HXX */

