#ifndef _VDHANDLE_HXX
#define _VDHANDLE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdHandle.hxx                                      *
*  Date: 31-10-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Benary, J. Hutschenreiter                    *
*  State of Realization: experimental version              *
*                                                          *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdHandle;

/******************    dependences    *********************/

#include <Vd/VdFeature.hxx>
#include <Vd/VdPoint.hxx>
#include <Vd/VdString.hxx>
#include <Vd/VdPicturePtrList.hxx>
#include <Vd/VdConsistence.hxx>
#include <Vd/VdEvent.hxx>

class VdPicture;

class VdHandle{

  friend class VdPicture;
  
  VdPicturePtrList insertedIn;

  void addPicture ( VdPicture * );
  void remPicture ( VdPicture * );
  void clearPicture ( void );


 public:

  VdFeature type;   // muss zum Ereignistyp passen
  VdString name;    // Bezeichnung der Behandlung

  VdHandle( void );
  VdHandle( VdHandle & );

  virtual ~VdHandle ( void );

  virtual int test ( VdEvent * theEvent
                   , VdPicture * thePicture
                   );

  virtual void enter ( VdEvent * theEvent
                     , VdPicture * thePicture
                     );
  virtual void leave ( VdEvent * theEvent
                     , VdPicture * thePicture
                     );

  virtual void execute ( VdEvent * theEvent
                       , VdPicture * thePicture
                       );

};

#endif /* _VDHANDLE_HXX */
