#ifndef _VDHELP_HXX
#define _VDHELP_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdHelp.hxx                                        *
*  Date: 28-07-93                                          *
*  Copyright (c) 1993                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: B. Miethig, J. Hutschenreiter                   *
*  State of Realization:  experimental version             *
************************************************************
*                                                          *
*                                                          *
***********************************************************/

#include <Vd/VdFeature.hxx>
#include <Vd/VdFeatureList.hxx>
#include <Vd/VdString.hxx>
#include <Vd/VdTopic.hxx>
#include <Vd/VdTopicList.hxx>
#include <Vd/VdHelpPtrList.hxx> 
#include <Vd/VdStringList.hxx>

#define HELP_REALIZATION VdHelpMemory
#define HELP_INCLUDE <Vd/VdHelpMemory.hxx>

class VdHelp{
	friend class VdHelpManager;
   private:
	static VdHelpPtrList helpObjects;
	VdFeature theIdent;
	VdString  theTitle;
	VdTopicList theSubTopics;

	void updateSubTopics( void ); 
	void updateFathers( void );

	VdHelpPtrList getAllFathers( void );

	void clearSubTopic( VdHelp * help );
	void remove( void ) ;

   public:	
	VdHelp( const VdString & theTitle, 
		const VdFeature & theIdf,	
		VdTopicList & subTopics,
		int toUpdate=1);
	static void update( void );
	static int parseHelpFile( 
		const VdString & filename );
	~VdHelp();
	static VdHelp * getObject(const VdFeature &ident);
	VdFeature & getIdent(void);

	// modifying existing help objects
	void addSubTopic(const VdFeature & ident,
			int update = 1);
	void remSubTopic(const VdFeature & ident);

	// interface for VdHelpWindow

	VdString getTitle(void);
	VdStringList getSubTopics( void );

	virtual VdString getHelpText();

};

#endif       // _VDHELP_HXX
