#define _VDHELPMANAGER_CXX
extern "C" {
#include <stdlib.h>
#include <stdio.h>
}
#include <Vd/VdHelpManager.hxx>
#include <Vd/VdHelpPtrList.hxx>
#include <Vd/VdString.hxx>
#include <Vd/VdFeature.hxx>
#include <Vd/VdHelpManager.hxx>
#include <Vd/VdShell.hxx>
#include <Vd/VdHelpMemory.hxx>

int VdHelpManager::isInit=0;

VdHelpManager::VdHelpManager( int dynamic )
{
	if (!isInit) init( 0 );
	activeHelp=NULL;
	dynamicObject=dynamic;
}

VdHelpManager::VdHelpManager( 
		VdString &fileName, int dynamic )
{
	helpFile=fileName;
	init( 1 );
	activeHelp=NULL;
	dynamicObject=dynamic;
}

void VdHelpManager::init( int mode )
{
	int res; 
	char *filename;
	VdFeature allTopic("*");
	VdTopicList dummy;
	VdString allTitle("VISAMAD Help System");
	VdString allHelp("\n\n\n      No help available\n\n");

	switch (mode) {
	case 0: {
		filename = 
		    XGetDefault(VdShell::theDisplay,
			VdShell::theClassName,"helpfile");
		if (!filename) {
		    helpFile = VdString("helpfile.hlp");
		    if (!VdHelp::parseHelpFile(helpFile))
			new VdHelpMemory(
				allTitle, allTopic,
				dummy, allHelp, 0);
		    break;  // no message
		} // else parsing
		helpFile = VdString(filename);
		}
	case 1:
		res = VdHelp::parseHelpFile(helpFile);
		if (!res) {
		    char buffer[100];
		    sprintf(buffer,"Can not open helpfile %s\n",
			helpFile.charptr());
		    XtWarning(buffer);
		}
	}
	isInit = 1;
}

void VdHelpManager::handleHelp(const VdFeature &idf)
{
	activeHelp = VdHelp::getObject(idf);
	if (!activeHelp) return;
	theHelpChain.ins() = activeHelp;
	idxActiveHelp = 0;
	theHelpWindow = 
		new VdHelpWindow(
		    this,
		    activeHelp->theTitle,
		    activeHelp->getSubTopics(),
		    activeHelp->getHelpText()
		);
	theHelpWindow->map();
}

void VdHelpManager::handleSelection( int selection )
{
	VdHelpMemory * help = (VdHelpMemory *)activeHelp;
	switch(selection) {
	case -3:  if (dynamicObject) delete this;
		break;
	case -2: {
		if (idxActiveHelp>0) {
		    idxActiveHelp--;
		    activeHelp = theHelpChain[idxActiveHelp];
		    theHelpChain.ins() = activeHelp;
		}
		theHelpWindow->set(
		    activeHelp->theTitle,
		    activeHelp->getSubTopics(),
		    activeHelp->getHelpText()
		);
		}
		break;
	case -1: 
		(new VdHelpManager(1))
			->handleHelp(activeHelp->theIdent);
		break;
	default: {
		if (selection >= !activeHelp->theSubTopics)
			break;
		activeHelp = activeHelp->
			theSubTopics[selection].theHelp;
		if (!activeHelp) { activeHelp = help; break; }
		idxActiveHelp = !theHelpChain;
		theHelpChain.ins() = activeHelp;
		theHelpWindow->set(
		    activeHelp->theTitle,
		    activeHelp->getSubTopics(),
		    activeHelp->getHelpText()
		);
		}
		break;
	}
}

#undef _VDHELPMANAGER_CXX	
