#ifndef _VDHELPWINDOW_HXX
#define _VDHELPWINDOW_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdHelpWindow.hxx                                  *
*  Date: 28-07-93                                          *
*  Copyright (c) 1993                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization:  experimental version (stdio)     *
************************************************************
*                                                          *
*                                                          *
***********************************************************/

class VdHelpManager;

#include <Vd/VdString.hxx>
#include <Vd/VdStringList.hxx>
#include <Vd/VdHelpManager.hxx>
#include <Vd/VdCBmanager.hxx>

#include <Vd/VdShell.hxx>

#define VdListClassName VdWidgetList
#define VdListClassElementType Widget

#include <Vd/VdListDeclaration.mxx>

#undef VdListClassName
#undef VdListClassElementType


class VdHelpWindow: public VdCBmanager {
	VdString theTopic;
	VdString theHelpText;
	VdStringList theSubTopics;
	int isMapped;
	VdHelpManager *theManager;
	// Motif stuff:
	VdShell *theShell;
	Widget theMenuBar;
	Widget theTopicBar;
	Widget theHelpDisplay;
	Widget theMainWindow;
	Widget theCloseButton, 
		thePreviousButton, 
		theWindowButton;
	void setMotifValues( void );
	void createMotifObjects( void );
	VdWidgetList theTopicButtons;
public: 
	VdHelpWindow( VdHelpManager *manager );
	VdHelpWindow(
		VdHelpManager *manager,
		VdString topic,
		VdStringList subtopics,
		VdString helpText);
	~VdHelpWindow( void );
	void set(
		VdString topic,
		VdStringList subtopics,
		VdString helpText);
	void map( void );
	void unmap( void );

	virtual void handleActivated( void );
};

#endif 	// _VDHELPWINDOW_HXX
