#ifndef _VDHEXAGON_HXX
#define _VDHEXAGON_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdHexagon.hxx                                     *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdHexagon;

/******************    dependences    *********************/

#include <Vd/VdPicture.hxx>
#include <Vd/VdArc.hxx>
#include <Vd/VdLine.hxx>

 
class VdHexagon : public VdPicture 
{
     int a, b;
     VdLine up, down, uleft, dleft, uright, dright;


  public : 

     VdHexagon(int     aa      = 10,
               int     bb      = 10 
              ); 
 
     VdPicture* duplicate(void);
     void setAxisA     ( int aa );
     void setAxisB     ( int bb );
     void setRectangle( const VdArea & ar );

     int        getAxisA      ( void ) const; 
     int        getAxisB      ( void ) const; 
     VdPoint getBorderPoint( VdPoint & p );

     virtual void manipulate( void );

};

#endif /* _VDHEXAGON_HXX */
