#define _VDLANGUAGEBACKGROUND_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdLanguageBackGround.cxx                          *
*  Date: 22-04.93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

#include <Vd/VdLanguageBackGround.hxx>
#include <Vd/VdGlobalFunctions.hxx>
#include <Vd/VdHandle.hxx>
#include <stdarg.h>


VdLanguageBackGround::VdLanguageBackGround( void )
{
}

VdLanguageBackGround::VdLanguageBackGround( const VdLanguageBackGround &  )
{
}

int VdLanguageBackGround::VdCreateAndHandleFormular(char * name, char * group, ... )
{ va_list ap;
  va_start(ap,group);
  VdFormularInterface frm;
  frm.formularName=VdString(name);
  VdFeature grp(group);
  int i; char * ptr;
  while(1)
  { ptr=va_arg(ap,char*);
    if (ptr==NULL) break;
    VdString mem(ptr);
    for (i=0; i<!VdEntries; i++)
      if (  ( mem == VdEntries[i]->name )
         && ( grp == VdGroup[i] )
         )
      { frm.entries.ins()=VdEntries[i];
        break;
      }
  }
  va_end(ap);
  if (!frm.entries)
  { return ::VdCreateAndHandleFormular(&frm);
  }
  return 0;
}

void VdLanguageBackGround::VdRegisterFormular(char * grp, VdFormularEntry * e )
{ VdEntries.ins(0)=e;
  VdGroup.ins(0)=VdFeature(grp);
}

void VdLanguageBackGround::VdRegisterHandle( VdHandle* h )
{ VdHandles.ins()=h;
}

void VdLanguageBackGround::VdAddHandles( VdPicture* pict, ... )
{ va_list ap;
  va_start(ap,pict);
  int i; char * ptr;
  while(1)
  { ptr=va_arg(ap,char*);
    if (ptr==NULL) break;
    VdString mem(ptr);
    for (i=0; i<!VdHandles; i++)
      if ( mem == VdHandles[i]->name )
      { pict->include(VdHandles[i]);
        break;
      }
  }
  va_end(ap);
}

void VdLanguageBackGround::VdRemHandles( VdPicture* pict, ... )
{ va_list ap;
  va_start(ap,pict);
  int i; char * ptr;
  while(1)
  { ptr=va_arg(ap,char*);
    if (ptr==NULL) break;
    VdString mem(ptr);
    for (i=0; i<!VdHandles; i++)
      if ( mem == VdHandles[i]->name )
      { pict->exclude(VdHandles[i]);
        break;
      }
  }
  va_end(ap);
}

void VdLanguageBackGround::VdClearHandles( VdPicture* pict )
{ pict->clearHandles();
}


#undef _VDLANGUAGEBACKGROUND_CXX
