#ifndef _VDLANGUAGEBACKGROUND_HXX
#define _VDLANGUAGEBACKGROUND_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdLanguageBackGround.hxx                          *
*  Date: 22-04.93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdLanguageBackGround;

/******************    dependences    *********************/

#include <Vd/VdFormularInterface.hxx>
#include <Vd/VdFormularEntry.hxx>
#include <Vd/VdFormularEntryPtrList.hxx>
#include <Vd/VdFeatureList.hxx>
#include <Vd/VdHandlePtrList.hxx>
#include <Vd/VdPicture.hxx>
 
class VdLanguageBackGround
{  VdFormularEntryPtrList VdEntries;
   VdFeatureList VdGroup;
   VdHandlePtrList VdHandles;
   
 public:
   VdString VdSelectionIdentifier;
   VdLanguageBackGround(void);
   VdLanguageBackGround( const VdLanguageBackGround & b );
   int VdCreateAndHandleFormular(char * name, char * grp, ... );
   void VdRegisterFormular(char * grp, VdFormularEntry * e );
   void VdRegisterHandle( VdHandle* h );
   void VdAddHandles( VdPicture* pict, ... );
   void VdRemHandles( VdPicture* pict, ... );
   void VdClearHandles( VdPicture* pict );
   virtual const VdString& getSelectionIdentifier(void)=0;
   virtual const VdString& VdGetLanguageName(void)=0;
};

#endif /* _VDLANGUAGEBACKGROUND_HXX */
