#ifndef _VDLANGUAGEINTERFACE_HXX
#define _VDLANGUAGEINTERFACE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdLanguageInterface.hxx                           *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdLanguageInterface;

/******************    dependences    *********************/

#include <Vd/VdSublanguage.hxx>
#include <Vd/VdString.hxx>

class VdLanguageInterface
{
  public:

  friend class VdSublanguage;
  friend class VdReference;
  friend class VdVisamadSystem;

  VdSublanguage * VdOriginPtr;
  VdString VdLanguageName;
  
  VdLanguageInterface( const VdString & name);
  VdLanguageInterface( const VdLanguageInterface & x);
  virtual ~VdLanguageInterface(void);

  const VdString & VdGetLanguageName( void );
  virtual VdLanguageInterface * VdDuplicateLanguage( void ) = 0;
  virtual VdLanguageInterface * VdGetLanguageInterface( const VdString & name) = 0;

  int operator == ( const VdLanguageInterface & ) const;
  int operator != ( const VdLanguageInterface & ) const;

};

#endif /* _VDLANGUAGEINTERFACE_HXX */
