#ifndef _VDLINE_HXX
#define _VDLINE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdLine.hxx                                        *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdLine;

/******************    dependences    *********************/

#include <Vd/VdPicture.hxx>
#include <Vd/VdPoint.hxx>


class VdLine : public VdPicture 
{
       VdPoint    startPoint,
                  endPoint;

   public : 
     

     VdLine( const VdPoint & from = VdNullPoint, 
             const VdPoint & to   = VdNullPoint
           );
 
     VdLine( const VdPoint & from, 
             const VdVector & v, 
             int betrag     = 1
           ); 

     VdPicture * duplicate(void);

     void setStartPoint ( const VdPoint & p );
     void setEndPoint   ( const VdPoint & p ); 

     VdPoint    getStartPoint ( void ) const ;
     VdPoint    getEndPoint   ( void ) const ;

     virtual void prepare ( void );

     virtual void computeFrame ( void );
 
     virtual void draw( VdGeometricContext * G
                      , VdGraphicAttributes GA
                      ); 
     virtual void printPostScript(FILE* f);
      virtual void print( int );
 
}; 
 
#endif /* _VDLINE_HXX */
