#ifndef _VDLINETYPE_HXX
#define _VDLINETYPE_HXX
 
/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdLineType.hxx                                    *
*  Date: 27-01-93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Benary, B. Miethig, J. Hutschenreiter        *
*  State of Realization:  experimental version             *
************************************************************
*                                                          *
*     Definition of classes                                *
*        VdFillType                                        *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdLineType;

/******************    dependences    *********************/
 
class VdLineType{
  int code;
  int width;

 public:

  friend void InitGraphicAttributes(Display *dp);

  VdLineType(void) { code = -1; width = -1; }
  VdLineType(const int aType) ;
  int Code(void) const { return code; }
  int Width(void) const { return width; }


  VdLineType operator()(int w) const;


  int operator==(const VdLineType & c) const;
  int operator!=(const VdLineType & c) const;
}; 
 
/********************** constants **************************/

extern const VdLineType VdLINESOLID,
                        VdLINEDASH,
                        VdLINEDOUBLEDASH,
                        VdLINEUNDEF; 

#endif  /* _VDLINETYPE_HXX */
