#define _VDMAGNIFIERBUTTON_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdMagnifierButton.cxx                             *
*  Date: 30-11-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*                                                          *
*     experimental declaration of class VdMagnifierButton: *
*       VdButton is derived from VdButton for realizing    *
*       menu buttons in the magnifier window's menubar.    *
*       Activation of such a button switchs the magnifier  *
*       to the corresponding edit window                   *
*                                                          *
*                                                          *
*     Interface                                            *
*          VdMagnifierButton.hxx, VdMagnifierWindow.hxx,   *
*          VdEditWindow.hxx                                *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdMagnifierButton.hxx>
#include <Vd/VdEditWindow.hxx>
#include <Vd/VdString.hxx>

VdMagnifierButton::VdMagnifierButton( VdMagnifierWindow * mw,
			VdFeature &ident, 
			VdWindowConnection *wc):
	VdButton( *mw,
		  ((ident.getLast(1))
			.getString()).charptr()
		 )
{
	mwPtr = mw;
	ewIdent = ident;
	wcPtr = wc;
}

VdMagnifierButton::~VdMagnifierButton( void )
{
}

void VdMagnifierButton::handleActivated( void )
{
	if (wcPtr) wcPtr->magnify(ewIdent);
}

#undef _VDMAGNIFIERBUTTON_CXX
