#ifndef _VDMAGNIFIERBUTTON_HXX
#define _VDMAGNIFIERBUTTON_HXX

/***********************************************************
*                   VISAMAD.defgraph                       *
*               ==========================                 *
*  File: VdMagnifierButton.hxx                             *
*  Date: 30-11-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*                                                          *
*     experimental declaration of class VdMagnifierButton: *
*       VdButton is derived from VdButton for realizing    *
*       menu buttons in the magnifier window's menubar.    *
*       Activation of such a button switchs the magnifier  *
*       to the corresponding edit window                   *
*                                                          *
*                                                          *
*     Interface                                            *
*          VdButton.hxx, VdFeature.hxx                     *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

// class VdMagnifierButton;

/******************    dependences    *********************/

#include <Vd/VdButton.hxx>
#include <Vd/VdFeature.hxx>
#include <Vd/VdMagnifierWindow.hxx>
#include <Vd/VdWindowConnection.hxx>

class VdMagnifierButton: public VdButton {
   private:
	VdFeature ewIdent;
	VdMagnifierWindow * mwPtr;
	VdWindowConnection *wcPtr;
   protected:
	~VdMagnifierButton( void );

   public:
	VdMagnifierButton( VdMagnifierWindow * mw, 
			VdFeature & ewIdent, 
			VdWindowConnection *wc);
	virtual void handleActivated( void );
};


#endif  /* _VDMAGNIFIERBUTTON_HXX */
