#define _VDMESSAGE_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdMessage.cxx                                     *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdMessage.hxx>

#define VdListClassName VdMessagePtrList
#define VdListClassElementType VdMessage*
#include <Vd/VdListDefinition.mxx>
#undef VdListClassName
#undef VdListClassElementType

VdMessage::~VdMessage(void)
{ const VdMessage * mptr = this;
  Objects.rem(Objects.idx(mptr,0));
}

void VdMessage::AddReceiver(void)
{ 
  const VdMessage* p = (const VdMessage *)this;
  if (Objects.idx(p,0)<0)
    Objects.ins()=(VdMessage *)this;
}

void VdMessage::RemoveReceiver(void)
{ 
  const VdMessage* p = (const VdMessage *)this;
  Objects.rem(Objects.idx(p,0));
}

int VdMessage::Send( const VdFeature & receiver
                   , const VdFeature & reason
                   , void * info
                   )
{ int i, j;
  for (i=j=0; i<!Objects; i++)
    if (Objects[i]->Receiver==receiver)
    { Objects[i]->ReceiveMessage(reason,info);
      j++;
    }
  return j;
}

#undef _VDMESSAGE_CXX
