#ifndef _VDMESSAGE_HXX
#define _VDMESSAGE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdMessage.hxx                                     *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdMessage;

/******************    dependences    *********************/

#include <Vd/VdFeature.hxx>

#define VdListClassName VdMessagePtrList
#define VdListClassElementType VdMessage*
#include <Vd/VdListDeclaration.mxx>
#undef VdListClassName
#undef VdListClassElementType

class VdMessage{

  static VdMessagePtrList Objects;

 public:

  VdFeature Receiver;         // Kennzeichen des Empfaengers

  ~VdMessage(void);

  void AddReceiver(void);     // Empfaenger anmelden
  void RemoveReceiver(void);  // Empfaenger abmelden

  virtual void ReceiveMessage
         ( const VdFeature & theReason
         , void * information
         ) =0;               // spezielle Empfangsmethode

  static int Send( const VdFeature & receiver
                 , const VdFeature & reason
                 , void * information
                 );
};

/******************     constants     *********************/ 
 
#ifdef _VDMESSAGE_CXX

   VdMessagePtrList VdMessage::Objects;

#endif

#endif /* _VDMESSAGE_HXX */
