#ifndef _VDNET_HXX
#define _VDNET_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdNet.hxx                                         *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdNet;

/******************    dependences    *********************/

#include <Vd/VdPicture.hxx>
#include <Vd/VdPointList.hxx>

 
class VdNet : public VdPicture 
{
     VdPointList pnt1, pnt2;
     VdVector or1, or2;
     int dist;
  public : 

     VdNet( VdVector & v1 = VdNullVector
          , VdVector & v2 = VdNullVector
          ); 
 
     void clear(void);
     void setSegmentOrientation(VdVector & v );
     void setLineOrientation(VdVector & v );
     VdVector getSegmentOrientation(void);
     VdVector getLineOrientation(void);
     void addPoint1( VdPoint & p );
     void addPoint2( VdPoint & p );
     VdPoint getBestPoint( VdPoint & p );
     virtual void manipulate( void );

};

#endif /* _VDNET_HXX */
