#ifndef _VDNODE_HXX
#define _VDNODE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdNode.hxx                                        *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdNode;

/******************    dependences    *********************/

#include <Vd/VdPicture.hxx>
#include <Vd/VdOval.hxx>
#include <Vd/VdHexagon.hxx>
#include <Vd/VdRectangle.hxx>
#include <Vd/VdArc.hxx>
#include <Vd/VdText.hxx>

#define VdRectNode 0
#define VdArcNode 1
#define VdHexNode 2
#define VdOvalNode 3
 
class VdNode : public VdPicture 
{
     VdText * text;
     VdPicture * border;
     int xSpace, ySpace, nodeType;

  public : 

     VdNode(int nt = VdRectNode ); 
     VdNode( VdNode & node );
     VdPicture* duplicate(void);
     void setXSpace( int aa );
     void setYSpace( int bb );
     int getXSpace( void ) const; 
     int getYSpace( void ) const;

     void setNodeType( int nt );
     int getNodeType( void ) const; 

     void setText( VdString & s );
     VdText & getText( void ) ;

     VdPoint getBorderPoint( VdPoint & p );

     virtual void manipulate( void );
     virtual void layout( void );

};

#endif /* _VDNODE_HXX */
