#ifndef _VDOVAL_HXX
#define _VDOVAL_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdOval.hxx                                        *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdOval;

/******************    dependences    *********************/

#include <Vd/VdPicture.hxx>
#include <Vd/VdArc.hxx>
#include <Vd/VdLine.hxx>

 
class VdOval : public VdPicture 
{
     int a, b;
     VdLine up, down;
     VdArc left, right;


  public : 

     VdOval(int     aa      = 10,              // Hauptscheitel         
            int     bb      = 10              // Nebenscheitel      
          ); 
 
     VdPicture* duplicate(void);
     void setAxisA     ( int aa );
     void setAxisB     ( int bb );
     void setRectangle( const VdArea & ar );

     int        getAxisA      ( void ) const; 
     int        getAxisB      ( void ) const; 
     VdPoint getBorderPoint( VdPoint & p );

     virtual void manipulate( void );
     virtual void layout( void );

};

#endif /* _VDOVAL_HXX */
