#define _VDPIXMAP_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdPixMap..cxx                                      *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdPixMap.hxx>

#ifdef _HXX_INCLUDE_
#include <stdio.hxx>
#include <string.hxx>
#else
#include <stdio.h>
#include <string.h>
#endif

VdPixMap::VdPixMap( void )
{ pixels=NULL;
}

VdPixMap::VdPixMap( VdPixMap & p )
{ xpixels=p.xpixels; ypixels=p.ypixels;
  pixels=new char[xpixels*ypixels];
  memcpy(pixels,p.pixels,xpixels*ypixels);
}

VdPixMap & VdPixMap::operator =( VdPixMap & p )
{ xpixels=p.xpixels; ypixels=p.ypixels;
  pixels=new char[xpixels*ypixels];
  memcpy(pixels,p.pixels,xpixels*ypixels);
  return *this;
}

void VdPixMap::setSize( int x ,int y )
{ xpixels=x; ypixels=y; pixels=new char[x*y];
}

int VdPixMap::getXSize( void )
{ return xpixels;
}

int VdPixMap::getYSize( void )
{ return ypixels;
}

int VdPixMap::getAreaLength( void )
{ return xpixels*ypixels;
}

char * VdPixMap::getArea( void )
{ return pixels;
}

int VdPixMap::write( VdString & s )
{ FILE * f; int i; char * ptr;
  if ((f=fopen(s.charptr(),"w"))==NULL) return 0;
  fprintf(f,"%d\n%d\n",xpixels,ypixels);
  for ((i=xpixels*ypixels,ptr=pixels); i; (i--,ptr++))
  { fprintf(f,"%d",*ptr);
    if (i&0xF) fprintf(f," ");
    else fprintf(f,"\n");
  }
  fclose(f);
  return 1;
}

int VdPixMap::operator ==( VdPixMap & p ) const
{ return this==&p;
}

int VdPixMap::operator !=( VdPixMap & p ) const
{ return this!=&p;
}

VdPixMap::~VdPixMap( void )
{ if (pixels) delete pixels;
}

#undef _VDPIXMAP_CXX
