#define _VDPOINT_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdPoint.cxx                                       *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdPoint.hxx>


VdPoint::VdPoint ( const VdVector & v )
{ x = v.x; y = v.y; } 

VdPoint VdPoint::operator+ ( const VdVector & v ) const
{ VdPoint h( x + v.x, y + v.y); 
  return h; 
} 

VdPoint VdPoint::operator- ( const VdVector & v ) const
{ VdPoint h(x - v.x, y - v.y); 
  return h; 
} 
 
VdPoint & VdPoint::operator+= ( const VdVector & v )
{ x += v.x; y += v.y; 
  return *this; 
} 

VdPoint & VdPoint::operator-= ( const VdVector & v )
{ x -= v.x; y -= v.y; 
  return *this; 
} 

VdVector VdPoint::operator- ( const VdPoint & p ) const
{ VdVector v; 
  v.x = x - p.x; 
  v.y = y - p.y; 
  return v; 
} 

int VdPoint::operator== ( const VdPoint & p ) const
{ return (x == p.x) && ( y == p.y);
} 
 
int VdPoint::operator!= ( const VdPoint & p ) const
{ return (x != p.x) || ( y != p.y);
} 


VdPoint VdPoint::rotate ( int arc , char we ) const
{ return ( ((VdVector)(*this)).rotate(arc, we) ); 
} 
 
#undef _VDPOINT_CXX
