#ifndef _VDPOLYARROW_HXX
#define _VDPOLYARROW_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdPolyArrow.hxx                                   *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdPolyArrow;

/******************    dependences    *********************/

#include <Vd/VdPicture.hxx>
#include <Vd/VdPointList.hxx>

class VdPolyArrow : public VdPicture 
{
       VdPointList points;
       int isModified;

   public : 
     
     VdPolyArrow( const VdPoint & from = VdNullPoint, 
                  const VdPoint & to   = VdNullPoint
                );
 
     VdPicture * duplicate(void);

     void setStartPoint  ( const VdPoint & p );
     void setEndPoint    ( const VdPoint & p );
     void setIntermediate( int i, const VdPoint & p );
     void remIntermediate( int i = -1 );

     int hasIntermediate (void) const;

     VdPoint getStartPoint  ( void );
     VdPoint getEndPoint    ( void );
     VdPoint getIntermediate( int i );

     void reverse(void);

     int distance( const VdPoint & p );

     virtual void prepare ( void );
 
     virtual void print( int );
 
}; 
 
#endif /* _VDPOLYARROW_HXX */
