#define _VDPOPUPMENU_CXX

/***********************************************************
*                     VISAMAD.defgraph                     *
*                ==========================                *
*  File: VdPopupMenu.cxx                                   *
*  Date: 06-01-93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdPopupMenu.hxx>
#include <Vd/VdPopupMenuInterface.hxx>
#include <Vd/VdCascadeMenu.hxx>
#include <Vd/VdWindowConnection.hxx>
#include <Vd/VdGlobalFunctions.hxx>

#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/CascadeB.h>
#include <Xm/RowColumn.h>
#include <Xm/PushB.h>
#include <Xm/Separator.h>
#include <Xm/MwmUtil.h>
#include <Xm/MainW.h>
#include <Xm/Form.h>
#include <Xm/BulletinB.h>

extern "C" {
#include <stdio.h>
}

// internal list of cascade menus windows 
// search only for widget

int VdCascadeMenuListEntry::operator== ( 
	const VdCascadeMenuListEntry & le) const
{
	if ( le.widget == widget)
		return 1;
	else
		return 0;
}

int VdCascadeMenuListEntry::operator!= ( 
	const VdCascadeMenuListEntry & le) const
{
	if ( le.widget != widget)
		return 1;
	else
		return 0;
}

#define VdListClassName VdCascadeMenuList
#define VdListClassElementType VdCascadeMenuListEntry

#include <Vd/VdListDefinition.mxx>

#undef VdListClassName
#undef VdListClassElementType


static Widget cancelButton;
/* soll spaeter wieder entfernt werden und ist deshalb
   kein class member */

VdPopupMenu::VdPopupMenu( Widget parent,
		VdFeature & window,
		VdPopupMenuInterface * interface,
		VdWindowConnection * connection)
{
	popupInterface = interface;
	allSelectedHandles = interface->selectedHandles;
	windowConnection = connection;
	(allSelectedHandles->theEvent).window = 
		parentWindow = window;
	parentWidget = parent;
	lastCascade = -1; toUnmap=1;
}

VdPopupMenu::~VdPopupMenu( void )
{
	XtDestroyWidget(XtParent(theMenu));
}

void VdPopupMenu::map ( void )
{
	Arg al[10];
	Cardinal ac;
	int i,l;
	VdCascadeMenuListEntry *le;
	Widget aButton, menuBar;
	VdCascadeMenu * cascade;
	Widget shell;


	XButtonPressedEvent lastEvent =
	    *(XButtonPressedEvent *)
		(getLastCallbackData()->event);

	ac=0;
	XtSetArg(al[ac], XmNmwmDecorations,
		MWM_DECOR_TITLE
		); ac++;
	shell = XmCreateDialogShell(parentWidget,
		"VisamadMenu",al,ac);
	ac=0;
	XtSetArg(al[ac], XmNx, (Position)lastEvent.x_root); ac++;
	XtSetArg(al[ac], XmNy, (Position)lastEvent.y_root); ac++;
	XtSetArg(al[ac], XmNdefaultPosition, False); ac++;
	XtSetArg(al[ac], XmNmarginHeight,0); ac++;
	XtSetArg(al[ac], XmNmarginWidth,0); ac++;
	XtSetArg(al[ac], XmNdialogStyle, 
		XmDIALOG_FULL_APPLICATION_MODAL); ac++;
	theMenu = XmCreateBulletinBoard(shell,
		"VisamadMenu",al,ac);
	ac=0;
	menuBar = XmCreateMenuBar( theMenu,
			"VisamadMenuBar", NULL, 0);
	ac=0;
	cancelButton = XmCreateCascadeButton( menuBar, "Close",al,ac);
	addCB(cancelButton,activated);
	XtManageChild( cancelButton );

	ac=0;
	theMenuPane = XmCreatePulldownMenu(
		menuBar,"VisamadMenu",al,ac);
	addCB(theMenuPane,unmapped);	// statt alter Zuordnung
	
	for (i=0; i<!allSelectedHandles->selections; i++) {
		l = !(allSelectedHandles->selections[i].handles);
		cascade = new VdCascadeMenu(
			theMenuPane,
			parentWindow, 
			allSelectedHandles->theEvent,
			allSelectedHandles->selections[i]);
		cascade->setPopup(this);
		addCB(cascade->getWidget(),unmapped);

		ac=0;
		XtSetArg(al[ac], XmNsubMenuId, 
			    cascade->getWidget()); ac++;
		aButton = XmCreateCascadeButton(
			theMenuPane,
			allSelectedHandles->selections[i].
				handles[0]->name.charptr(),
			al,ac);		
		addCB(aButton,cascaded);
		le = &menuList[!menuList]; 
		le->widget = aButton;
		le->cascadeMenu = cascade;
		XtManageChild(aButton);
	}
	ac=0;
	XtSetArg(al[ac], XmNsubMenuId, theMenuPane); ac++;
	selectButton = XmCreateCascadeButton( menuBar, "Select",al,ac);
	XtManageChild( selectButton );

	XtManageChild(menuBar);
	XtManageChild(theMenu);  
/* working but slowly: 
	XtCallActionProc(selectButton,"MenuBarSelect",
		(XEvent *)&lastEvent,NULL,0);
   The action StartDrag does not work like documented.
*/
}

void VdPopupMenu::handleCascaded( void )
{
	VdCascadeMenuListEntry le;
	le.widget = getLastWidgetOfEvent();
	int i = menuList.idx(le);
	if (i<0) return;
	lastCascade = i;
	VdHandle *handle =
	    allSelectedHandles->
		selections[lastCascade].handles[0];
	if (handle) {
		handle->enter(
			&(allSelectedHandles->theEvent),
			allSelectedHandles->
			    selections[lastCascade].thePicture);
	}
	if (windowConnection)
	    windowConnection->redrawPicture(
		allSelectedHandles->theEntirePicture);
}

void VdPopupMenu::handleLeave( void )
{
	if (toUnmap) {
		XtUnmapWidget(XtParent(theMenu));
		toUnmap=0;
	}
}

void VdPopupMenu::handleUnmapped( void )
{
	if (lastCascade == -1) return;
	VdHandle *handle =
	    allSelectedHandles->
		selections[lastCascade].handles[0];
	if (handle) {
		handle->leave(
			&(allSelectedHandles->theEvent),
			allSelectedHandles->
			    selections[lastCascade].thePicture);
	}
	lastCascade = -1;
	if (windowConnection)
	    windowConnection->redrawPicture(
		allSelectedHandles->theEntirePicture);
}

void VdPopupMenu::cancel( void )
{
	if (popupInterface) 
		popupInterface->cancel();
	delete this;
}

void VdPopupMenu::handleActivated( void )
{
// This function will called by activation of a
// button in the CascadeMenu or the Close button
// in the PopupMenu
	if (getLastWidgetOfEvent()==cancelButton){ 
		cancel(); 
		if (windowConnection)
		    windowConnection->redrawPicture(
			allSelectedHandles->
			 theEntirePicture);
		return; 
	}
	popupInterface->isExecuted = 1;
	popupInterface->globalHandling();
	if (windowConnection)
	    windowConnection->redrawPicture(
		allSelectedHandles->theEntirePicture);
	if (popupInterface->isMultiple) {
		XtMapWidget(XtParent(theMenu)); 
		toUnmap=1;
	} else
		cancel();
}

#undef _VDPOPUPMENU_CXX
