#ifndef _VDPOPUPMENU_HXX
#define _VDPOPUPMENU_HXX

/***********************************************************
*                     VISAMAD.defgraph                     *
*                ==========================                *
*  File: VdPopupMenu.hxx                                   *
*  Date: 06-01-93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*  Comment                                                 *
*     experimental declaration of class VdPopupMenu        *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdPopupMenu;

/******************    dependences    *********************/

#include <Vd/VdCBmanager.hxx>
#include <Vd/VdStringList.hxx>
#include <Vd/VdAllSelectedHandles.hxx>
#include <Vd/VdPopupMenuInterface.hxx>

class VdCascadeMenu;
class VdWindowConnection;

class VdCascadeMenuListEntry {
   public:
	Widget widget;
	VdCascadeMenu *cascadeMenu;
        int operator== ( const VdCascadeMenuListEntry & ) const;
        int operator!= ( const VdCascadeMenuListEntry & ) const;
	};

#define VdListClassName VdCascadeMenuList
#define VdListClassElementType VdCascadeMenuListEntry

#include <Vd/VdListDeclaration.mxx>

#undef VdListClassName
#undef VdListClassElementType

class VdPopupMenu: virtual public VdCBmanager {
   private:
	VdFeature parentWindow;
	VdCascadeMenuList menuList;
	int lastCascade, toUnmap;
	VdPopupMenu( void ); // not accessable
	VdAllSelectedHandles * allSelectedHandles;
	VdPopupMenuInterface * popupInterface;
	VdWindowConnection * windowConnection;
	
   protected:
	Widget theMenu;
	Widget parentWidget;
	Widget selectButton,theMenuPane;

   public:
	VdPopupMenu( Widget parent,
		VdFeature & window,
		VdPopupMenuInterface * interface,
		VdWindowConnection * connection);
	~VdPopupMenu( void );

	virtual void map( void );
	virtual void handleCascaded( void );
	virtual void handleLeave( void );
	virtual void handleUnmapped( void );
	virtual void handleActivated( void );
	void cancel (void );
};


#endif  /* _VDPOPUPMENU_HXX */

