#ifndef _VDPOPUPMENUINTERFACE_HXX
#define _VDPOPUPMENUINTERFACE_HXX

/***********************************************************
*                   VISAMAD.defgraph                       *
*              ==========================                  *
*  File: VdPopupMenuInterface.hxx                          *
*  Date: 25-01-93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*  experimental declaration of class PopupMenuInterface:   *
*     Such an Interface is constructor parameter for an    *
*     VdPopupMenu. Member isMultiple defines whether the   *
*     Popup menu will mapped after activation of a button  *
*     once more (until call of VdPopupMenu::cancel).       *
*     Member isExecuted becomes True if one ore more       *
*     activations are executed. Function cancel will be    *
*     called from call of VdPopupMenu::cancel to handle    *
*     canceling and after button activation in the case    *
*     of isMultiple==False                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdPopupMenuInterface ;

/******************    dependences    *********************/

#include <Vd/VdAllSelectedHandles.hxx>

class VdPopupMenuInterface {
 public:
  int isMultiple; 
  int isExecuted;
  VdAllSelectedHandles * selectedHandles;
  VdPopupMenuInterface ( void );
  virtual void globalHandling( void );
  virtual void cancel( void );
};

#endif /* _VDPOPUPMENUINTERFACE_HXX */
