#ifndef _VDPULLDOWNOPTIONS_HXX
#define _VDPULLDOWNOPTIONS_HXX

/***********************************************************
*                   VISAMAD.defgraph                       *
*              ==========================                  *
*  File: VdPulldownOptions.hxx                             *
*  Date: 06-01-93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*  Comment                                                 *
*    experimental declaration of class VdPulldownOptions:  *
*       Implementation of Pulldown-Radioboxes and          *
*       Pulldown-Checkboxes.                               *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdPulldownOptions;

/******************    dependences    *********************/

#include <Vd/VdButton.hxx>
#include <Vd/VdToggleList.hxx>
#include <Vd/VdFeature.hxx>
#include <Vd/VdAbstractWindow.hxx>

class VdPulldownOptions: public VdButton {

	const int oneOfMany;
	long selectedMask;
	Widget menuPane;
	VdToggleList * theToggleList;

   public:
	VdPulldownOptions( VdAbstractWindow &window , 
		String aLabelString,
		int onlyOne = 1,
		long initialSelectedMask = 1,
		VdButtonInterface * handle= NULL);
	~VdPulldownOptions( void );

	virtual void map( void );
        virtual void unmap( void );
        virtual void remove( void );
	virtual void update( void );
	void addOption( String newOption );
	void removeOption( String oldOption );
	void renameOption( String oldOption, 
			String newOption );
	void setSensitivity( int nr, int state );
	int getSelected( void );
	void setSelected( int nr );
	virtual void handleCascaded( void );
	virtual void handleValueChanged( void );
};


#endif  /* _VDPULLDOWNOPTIONS_HXX */

