#ifndef _VDRECTANGLE_HXX
#define _VDRECTANGLE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdRectangle.hxx                                   *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdRectangle;

/******************    dependences    *********************/

#include <Vd/VdPicture.hxx>
#include <Vd/VdArea.hxx>


class VdRectangle : public VdPicture{ 

      VdArea rectangle;
 

  public : 

     VdRectangle( const VdPoint & p1 = VdNullPoint, 
                  const VdPoint & p2 = VdNullPoint
                ); 
     VdRectangle( const VdPoint & p1 , 
                  int width, int height
                ); 
     VdRectangle( const VdArea & a 
                );
 
     VdPicture * duplicate(void);

     void setRectangle( const VdPoint & p1 = VdNullPoint, 
                        const VdPoint & p2 = VdNullPoint
                      );
     void setRectangle( const VdPoint & p1 , 
                        int width, int height
                      );
     void setRectangle( const VdArea & a );

     VdArea     getRectangle ( void ) const;

     virtual void prepare ( void );

     virtual void computeFrame ( void );

     virtual void draw( VdGeometricContext * G
                      , VdGraphicAttributes GA 
                      ); 
     virtual void printPostScript(FILE* f);
      virtual void print( int );

}; 

#endif /* _VDRECTANGLE_HXX */
