#ifndef _VDREFERENCE_HXX
#define _VDREFERENCE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdReferenceAndSublanguage.hxx                     *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdReference;

/******************    dependences    *********************/

#include <Vd/VdReferencePtrList.hxx>
#include <Vd/VdString.hxx>

static void replaceReference( void*, void*, void* , int);

class VdReference
{
  public :

  friend class VdSublanguage;
  friend class VdLanguageInterface;
  friend class VdVisamadSystem;

  friend void replaceReference( void*, void*, void* , int);

  VdSublanguage * VdSublanguagePointer;
  VdString VdReferenceName;

  VdReference(void);
  VdReference( VdReference & x);
  ~VdReference(void);

  void VdSetReference( VdSublanguage * x );
  void VdRemReference( void );

  VdLanguageInterface * VdGetRealSlangPtr(void) const;

  int operator ! (void);
  void operator = ( VdReference & r );
  void operator = ( VdSublanguage & s );
  void refer( VdReference & r );
  void refer( VdReference * r );
  void refer( VdSublanguage & s );
  void refer( VdSublanguage * s );
  void refer( VdLanguageInterface & s );
  void refer( VdLanguageInterface * s );
  void derefer(void);
  int operator == ( const VdReference & ) const;
  int operator != ( const VdReference & ) const;
  int operator == ( const VdSublanguage & ) const;
  int operator != ( const VdSublanguage & ) const;
  int operator == ( VdLanguageInterface & ) const;
  int operator != ( VdLanguageInterface & ) const;
  int identically ( const VdReference & r ) const;

  /*  slang-type * operator -> ( void ) const; 
  */

};

#endif /* _VDREFERENCE_HXX */
