#ifndef _VDSUBLANGUAGE_HXX
#define _VDSUBLANGUAGE_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdSublanguage.hxx                                 *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdSublanguage;

/******************    dependences    *********************/

#include <Vd/VdLanguageInterface.hxx>
#include <Vd/VdReferencePtrList.hxx>
#include <Vd/VdString.hxx>

class VdSublanguage
{
  public :

  friend class VdLanguageInterface;
  friend class VdReference;

  VdLanguageInterface * VdRealSlangPtr;
  VdString VdSublanguageName;

  VdReferencePtrList VdReferencePtrs;
  
  void VdAddReference( VdReference * );
  void VdRemReference( VdReference * );
  void VdClearReferences( void );

  VdSublanguage (void);
  VdSublanguage ( VdSublanguage & x );
  ~VdSublanguage(void);

  void VdExchangeSlg( VdSublanguage * x );
  void VdExchangeRefPtrs( VdSublanguage * x );

  int operator ! (void) const;
  void operator = ( VdSublanguage & );
  void operator = ( VdReference & );
  void obtain( VdSublanguage & );
  void obtain ( VdReference & );
  int operator == ( const VdSublanguage & ) const;
  int operator != ( const VdSublanguage & ) const;
  int operator == ( const VdReference & ) const;
  int operator != ( const VdReference & ) const;
  int operator == ( VdLanguageInterface & ) const;
  int operator != ( VdLanguageInterface & ) const;

  /*  slang-type * operator -> ( void ) const; 
  */
 
};

#endif /* _VDSUBLANGUAGE_HXX */
