#ifndef _VDTEXT_HXX
#define _VDTEXT_HXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdText.hxx                                        *
*  Date: 29-09-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter , J.Benary                    *
*  State of Realization:                                   *
*   ( experimental version )                               *
************************************************************
*                                                          *
*  Comment                                                 *
*                                                          *
***********************************************************/

/******************  defined classes  *********************/

class VdText; 

/******************    dependences    *********************/
    
#include <Vd/VdPicture.hxx>
#include <Vd/VdString.hxx>


class VdText : public VdPicture
{
   public :

      static VdVector VdStandardSize;
      static VdString VdStandardString;

    private:

      VdString string;
      int lines, width;

    public :

      VdText ( const VdString & = VdStandardString
             , const VdVector & = VdStandardSize
             );
      VdText ( const VdText & );

      VdPicture * duplicate(void);

      void setString ( const VdString & );

      VdString getString (void) const;

      virtual void prepare (void);

      virtual void computeFrame (void);

      virtual void draw ( VdGeometricContext * G
                        , VdGraphicAttributes GA
                        );
     virtual void printPostScript(FILE* f);
      virtual void print( int );
};

/******************     constants     *********************/ 

#ifdef _VDPICTURESUMMARY_CXX

   VdVector VdText::VdStandardSize(6,10);
   VdString VdText::VdStandardString;

#endif

#endif /* _VDTEXT_HXX */
