#ifndef _VDTOGGLELIST_HXX
#define _VDTOGGLELIST_HXX

/***********************************************************
*                   VISAMAD.defgraph                       *
*              ==========================                  *
*  File: VdToggleList.hxx                                  *
*  Date: 06-01-93                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Hutschenreiter                               *
*  State of Realization: experimental version              *
************************************************************
*                                                          *
*  Comment                                                 *
*    An object of this class contains a number of Toggle-  *
*    Buttons and their behavior but without the parent     *
*    widget. The class is to be used for creating of       *
*    RadioBoxes in different widget hierarchies.           * 
***********************************************************/

/******************  defined classes  *********************/

class VdToggleList;

/******************    dependences    *********************/

#include <Vd/VdButtonInterface.hxx>
#include <Vd/VdCheckBoxInterface.hxx>
#include <Vd/VdRadioBoxInterface.hxx>
#include <Vd/VdCBmanager.hxx>
#include <Vd/VdDestruction.hxx>
#include <Vd/VdStringList.hxx>

class VdToggleList: public VdCBmanager,
		    public VdDestruction {

	const int oneOfMany;
	VdFeature theParentWindow;
	long selectedMask;
	VdStringList  optionLabels;
	Widget menuPane;
	Widget toggles[32];
	int nrToggles;
	VdButtonInterface * theHandle; 
		// really a VdRadioBoxInterface or an
		// VdCheckBoxInterface
   protected:
	~VdToggleList( void );

   public:
	VdToggleList( Widget parent ,
		VdFeature * parentWindow,
		VdButtonInterface * handle,
		int onlyOne = 1,
		long initialSelectedMask = 1 );

	void addOption( String newOption );
	void removeOption( String oldOption );
	void setSensitivity( int nr, int state );
	int getSelected( void );
	void setSelected( int nr );
	long getMask( void );
	void setMask( long mask );
	Widget getWidget( int nr );
	int getNrToggles( void );
	virtual void handleValueChanged( void );
	virtual void handleActivated( void );
};


#endif  /* _VDTOGGLELIST_HXX */

