#define _VDWINDOWMANAGERINTERFACE_CXX

/***********************************************************
*                    VISAMAD.defgraph                      *
*               ==========================                 *
*  File: VdWindowManagerInterface.cxx                      *
*  Date: 03-12-92                                          *
*  Copyright (c) 1992                                      *
*  Technical University Dresden, Department of Mathematics *
*  Author: J. Benary, J. Hutschenreiter                    *
*  State of Realization:  experimental version             *
************************************************************
*                                                          *
*     Dummy Implemantation of class                        *
*        VdWindowManagerInterface as a                     *
*        base class for application specific window        *
*        manager objects                                   *
*        Methods are not pure virtual because an           *
*        application may not use all methods               *
*                                                          *
*     Interface                                            *
*         VdWindowManagerInterface                         *
*                                                          *
***********************************************************/

/******************    dependences    *********************/

#include <Vd/VdWindowManagerInterface.hxx>
extern "C" {
#include <stdlib.h>
}


VdFeature VdWindowManagerInterface::createWindow
               ( const VdFeature & /*aWindow*/)
{
	return VdFeature("NIL");
}

void VdWindowManagerInterface::destroyWindows
               ( const VdFeature & /*someWindows*/ )
{
}

void VdWindowManagerInterface::renameWindow
		( const VdFeature & ,
		  const VdFeature & )
{
}

void VdWindowManagerInterface::mapWindow	
               ( const VdFeature & /*someWindows*/ )
{
}

void VdWindowManagerInterface::unmapWindow
               ( const VdFeature & /*someWindows*/ )
{
}

void VdWindowManagerInterface::setPicture 
               ( const VdFeature & /*someWindows*/
               , VdPicture * /*aPicture*/ )
{
}

VdPicture * VdWindowManagerInterface::getPicture
               ( VdFeature & /*aWindow*/ )
{
	return NULL;
}

void VdWindowManagerInterface::movePicture( 
		const VdFeature & /*aWindow*/, 
		VdPicture * /*toDraw*/, VdPicture * /*toMove*/,
		VdPoint * /*worldLocation*/)
{
}

VdFeature VdWindowManagerInterface::getWindowsOfPicture
               ( VdPicture * /*aPicture*/ )
{
	return VdFeature("NIL");
}


void VdWindowManagerInterface::setWorldArea 	
	       ( const VdFeature & /*someWindows*/,
		 const VdArea & /*worldArea*/ )
{
}

VdArea VdWindowManagerInterface::getWorldArea
	       ( const VdFeature & /*aWindow*/ )
{
	return VdEmptyArea;
}

void VdWindowManagerInterface::setDisplayArea 
	      	( const VdFeature & /*someWindows*/,
		  const VdArea & /*displayedArea*/ )
{
}

VdArea VdWindowManagerInterface::getDisplayArea
	       ( const VdFeature & /*aWindow*/ )
{
	return VdEmptyArea;
}

void VdWindowManagerInterface::setView(
		const VdFeature & /*someWindows*/,
		VdFractNumber /*editWindowUnitsByPixel*/,
		VdPoint /*editWindowCentre*/,
		VdFractNumber /*magnifierSizeInWindow*/,
		VdFractNumber /*magnifierXPosition*/,
		VdFractNumber/* magnifierYPosition*/)
{
}

void VdWindowManagerInterface::getView(
		const VdFeature & /*aWindow*/,
		VdFractNumber &/* editWindowUnitsByPixel*/,
		VdPoint & /*editWindowCentre*/,
		VdFractNumber & /*magnifierSizeInWindow*/,
		VdFractNumber & /*magnifierXPosition*/,
		VdFractNumber & /*magnifierYPosition*/)
{
}
void VdWindowManagerInterface::drawPicture
               ( VdPicture * /*aPicture*/ )
{
}

void VdWindowManagerInterface::redrawPicture
               ( VdPicture * /*aPicture*/ )
{
}

void VdWindowManagerInterface::setEventManager	
               ( const VdFeature & /*someWindows*/
               , VdEventManagerInterface * /*aManager*/ )
{
}

void VdWindowManagerInterface::removeEventManager
               ( const VdFeature & /*someWindows*/ )
{
}

void VdWindowManagerInterface::addButtons 
               ( const VdFeature & /*someWindows*/ 
               , VdButtonInterfacePtrList * /*buttons*/ )
{
}

void VdWindowManagerInterface::removeButtons
               ( const VdFeature & /*someWindows*/
               , VdButtonInterfacePtrList * /*buttons*/ )
{
}

void VdWindowManagerInterface::getImage
               ( const VdFeature & /*aWindow*/
               , VdPixMap & /*aPixmap*/)
{
}

void VdWindowManagerInterface::createAndHandleMenu(
		VdPopupMenuInterface * /*interface*/ )
{
}

void VdWindowManagerInterface::setExitChecker(
		int (*) (const VdFeature & window) )
{
}

void VdWindowManagerInterface::parseHelpFile(
		const VdString & )
{
}

void VdWindowManagerInterface::createHelpWindow(
		const VdFeature & )
{
}


#undef _VDWINDOWMANAGERINTERFACE_CXX
